SystemOrganization addCategory: 'Hyper'!

SpError subclass: #HyHeaderFieldParseError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

SpError subclass: #HyHTTPParseError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

SpError subclass: #HyHTTPRequestError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

HyHTTPRequestError subclass: #HyHTTPPostError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

HyHTTPRequestError subclass: #HyHTTPPutError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

OSkSocketInboundConnection subclass: #HTTPConnection
	instanceVariableNames: 'readStream writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPConnection methodsFor: 'handling' stamp: 'dkh 07/09/2007 10:30'!
getAndDispatchMessages
	"^self
	The HTTPRequest is read from my socket stream.  I then pass this request to my server to get a response.  If somethng goes wrong while getting hold of the request, we call that a 400 - a bad request.  If anything happens after that, it's an internal server error.  (hmm - should we close the image if we get an internal server error?  If we don't, what state is the image in, then ... ??)
The task request will be nil if the 'readRequestFor:' fails to read anything and times out. This is fine, we treat this to mean the connection has idled out and we close it. We don't handle multiple requests from the same pipeline if we're single threaded too, otherwise one client can lock up the server indefinitely.
The handling of the multple requests on a connection looks dodgy - for example, how can a task request be nil after we have read it and produced a response to it?  Needs review."

	| done |
	SpEnvironment workInProgress.
	
	done := false.
	[done] whileFalse: [| task |
	task := HyTask new.
	self readRequestFor: task.
	self produceResponseFor: task.
	done := task request isNil 
		or: [task request wantsConnectionClose or: [true]]].
	self close! !

!HTTPConnection methodsFor: 'logging' stamp: 'DataCurator 04/23/2007 14:43'!
isLoggingBytes
	"^a Boolean
I return true if my undrlying socket is currently required to log the bytes that pass through them, otherwise false."

	^self server isLoggingBytes! !

!HTTPConnection methodsFor: 'logging' stamp: 'DataCurator 04/23/2007 14:43'!
isLoggingMessages
	"^a Boolean
I return true if I am expected to log the messages I handle, otherwise false."

	^self server isLoggingMessages! !

!HTTPConnection methodsFor: 'handling' stamp: 'DataCurator 04/23/2007 14:43'!
nextPutError: aResponse
        "^self
I write out an error response.  I'm doing this because of a bad request or some other problem while dealing with an HTTP request.  If there has been a problem, there may be more.  If I hit a problem here, I just ignore it and continue.  The next thing to happen should the connection for this request being closed anyway."

        SpExceptionContext
                for:
                        [aResponse informConnectionClose.
                        aResponse writeTo: self writeStream]
                on: SpError
                do: [:ex | ].
        ^self! !

!HTTPConnection methodsFor: 'handling' stamp: 'DataCurator 04/23/2007 14:43'!
nextPutResponse: aMessage toRequest: aRequest 
	| shouldClose |
	shouldClose := aRequest wantsConnectionClose.
	shouldClose ifTrue: [aMessage informConnectionClose].
	aRequest isHead 
		ifTrue: [aMessage writeHeaderTo: self writeStream]
		ifFalse: [aMessage writeTo: self writeStream].
	self writeStream flush.
	shouldClose 
		ifTrue: [self close].! !

!HTTPConnection methodsFor: 'handling' stamp: 'dkh 07/09/2007 10:30'!
produceResponseFor: aTask 
	"^self
Given the request in aTask I try to make a response.  If there are any unhandled exceptions, respond with an internal server error."

	aTask request notNil 
		ifTrue: 
			[[[aTask response: (self server answerTo: aTask request).
			 self nextPutResponse: aTask response toRequest: aTask request] 
				on: HTTPSocketError do: [:ex | 
GsFile gciLogServer: 'produceResponseFor: browser closed connection'.
"safely ignore peer disconnects" self close ]]
					on: Error do: 
						[:ex | 
GsFile gciLogServer: 'produceResponseFor: internal server error: ', ex description.
						ex pass
						self nextPutError: HTTPResponse internalServerError.
						self close]]! !

!HTTPConnection methodsFor: 'handling' stamp: 'dkh 07/09/2007 10:30'!
readRequestFor: aTask 
	"^self
I read the next request from my socket and add it to aTask.  If I have any problems and need to force a bad request (400) response, I add this response to aTask."

	| request |
	SpExceptionContext 
		for: 
			[request := HTTPRequest readFrom: self readStream.
			(request httpVersion last = 1 
				and: [(request headers includesFieldOfClass: HTTPHostField) not]) 
					ifTrue: [aTask response: HTTPResponse badRequest].
			request
				peer: self socket getPeerName hostAddressString;
				ip: self socket getSocketName hostAddressString;
				setTimestamp.
			aTask request: request]
		on: SpError
		do: 
			[:ex | 
			aTask response: HTTPResponse badRequest.
			self nextPutError: aTask response.
			self close].
	^self! !

!HTTPConnection methodsFor: 'accessing' stamp: 'dkh 07/09/2007 10:30'!
readStream
	"^an HTTPReadStream
I return the stream I use to read OCTETs (bytes) from my socket."

	readStream isNil ifTrue: [readStream := HTTPReadStream onSocket: self socket].
	^readStream! !

!HTTPConnection methodsFor: 'logging' stamp: 'DataCurator 04/23/2007 14:43'!
startLoggingBytes
	"^self
I start logging the bytes that pass through my underlying socket to the default log."

	self readStream startLoggingTo: self server bytesLog.
	self writeStream startLoggingTo: self server bytesLog.
	^self! !

!HTTPConnection methodsFor: 'logging' stamp: 'DataCurator 04/23/2007 14:43'!
startLoggingMessages
	"^self
I start logging the messages I handle.  A message is a request or a response. This log will be a higher level semantic log of events, and some data may not be explicity retained from the bytes that flow over the socket.  c.f. >>startByteLog"

	1 halt! !

!HTTPConnection methodsFor: 'logging' stamp: 'DataCurator 04/23/2007 14:43'!
stopLoggingBytes
	"^self
c.f. >>startByteLog.  This is a no-op for now."

	^self! !

!HTTPConnection methodsFor: 'logging' stamp: 'DataCurator 04/23/2007 14:43'!
stopLoggingMessages
	"^self
c.f. >>startMessageLog"

	1 halt! !

!HTTPConnection methodsFor: 'accessing' stamp: 'dkh 07/09/2007 10:30'!
writeStream
	"^an HTTPWriteStream
I return the stream I use to read OCTETs (bytes) from my socket."

	writeStream isNil ifTrue: [writeStream := HTTPWriteStream onSocket: self socket].
	^writeStream! !

Object subclass: #HeaderField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

HeaderField class
	instanceVariableNames: 'httpFieldNameToClassDictionary'!

HeaderField subclass: #GenericHeaderField
	instanceVariableNames: 'name value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!GenericHeaderField class methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
newForFieldName: fieldNameString withValueFrom: fieldValueString 
	^self new forFieldName: fieldNameString andValue: fieldValueString! !

!GenericHeaderField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
combineWith: aHeaderField 
	"^self
I simply take my values and concatenate the values of aHeaderField."

	value := self value , ', ' , aHeaderField value.
	^self! !

!GenericHeaderField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
1 halt: 'use >>name instead'.
	^self name! !

!GenericHeaderField methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
forFieldName: fieldNameString andValue: fieldValueString 
	name := fieldNameString.
	value := fieldValueString.
	^self! !

!GenericHeaderField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
name
	^name! !

!GenericHeaderField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
value
	^value! !

!GenericHeaderField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
values
	^(SpStringUtilities tokensBasedOn: ',' in: self value) 
		collect: [:each | SpStringUtilities trimBlanksFrom: each]! !

!GenericHeaderField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: value.
	^self! !

!HeaderField class methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
classForFieldName: aString 
	"^a Class
If I can find a specific header field with a name matching aString I return that.  Otherwise I return the GenericHeaderField class."

	^self httpFieldNameToClassDictionary at: aString
		ifAbsent: [GenericHeaderField]! !

!HeaderField class methodsFor: 'instance creation' stamp: 'DataCurator 04/23/2007 14:43'!
fromLine: aString 
	| sourceStream fieldName fieldValue fieldClass |
	sourceStream := ReadStream on: aString.
	fieldName := (SpStringUtilities trimBlanksFrom: (sourceStream upTo: $:)) 
				asUppercase.
	fieldClass := self classForFieldName: fieldName.
	fieldValue := SpStringUtilities trimBlanksFrom: sourceStream upToEnd.
	^fieldClass newForFieldName: fieldName withValueFrom: fieldValue! !

!HeaderField class methodsFor: 'private' stamp: 'dkh 07/09/2007 10:30'!
httpFieldNameToClassDictionary
	"^a Class
I return the dictionarry of my subclasses keyed on the name of the field they represent.
Note that we only need *Request* headers listed in here because they are the only thing we will be parsing for."

	"After a change here, remeber to do 'HeaderField resetHttpFieldNameToClassDictionary' "

	httpFieldNameToClassDictionary isNil 
		ifTrue: 
			[| headerClasses |
			headerClasses := OrderedCollection new.
			headerClasses
				add: ContentDispositionField;
				add: HTTPContentLengthField;
				add: ContentTypeField;
				add: HTTPAcceptField;
				add: HTTPAuthorizationField;
				add: HTTPConnectionField;
				add: HTTPCookieField;
				add: HTTPHostField;
				add: HTTPIfMatchField;
				add: HTTPIfModifiedSinceField;
				add: HTTPIfNoneMatchField;
				add: HTTPIfRangeField;
				add: HTTPIfUnmodifiedSinceField;
				add: HTTPRefererField;
				add: HTTPUserAgentField.
			httpFieldNameToClassDictionary := Dictionary new.
			headerClasses do: 
					[:aClass | 
					httpFieldNameToClassDictionary at: aClass fieldName asUppercase put: aClass]].
	^httpFieldNameToClassDictionary! !

!HeaderField class methodsFor: 'initialize' stamp: 'DataCurator 04/23/2007 14:43'!
initialize
	"HeaderField initialize"
self resetHttpFieldNameToClassDictionary; httpFieldNameToClassDictionary! !

!HeaderField class methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
newForFieldName: fieldNameString withValueFrom: fieldValueString 
	^self subclassResponsibility! !

!HeaderField class methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
resetHttpFieldNameToClassDictionary
	
	httpFieldNameToClassDictionary := nil .
	^self! !

!HeaderField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
combineWith: aHeaderField 
	HyHeaderFieldParseError raiseSignal: 'Not supported'! !

!HeaderField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^self subclassResponsibility! !

!HeaderField methodsFor: 'private-initialize' stamp: 'DataCurator 04/23/2007 14:43'!
initialize! !

!HeaderField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isConditional
	^false! !

!HeaderField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isContentDisposition
	^false! !

!HeaderField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isContentType
	^false! !

!HeaderField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isTransferEncoding
	^false! !

!HeaderField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
name
	^self subclassResponsibility! !

!HeaderField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
printOn: aStream 
	aStream
		nextPutAll: self name;
		nextPutAll: ': ';
		nextPutAll: self valuesAsString.
	^self! !

!HeaderField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
value
^self valuesAsString! !

!HeaderField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
values
	^self subclassResponsibility! !

!HeaderField methodsFor: 'printing' stamp: 'dkh 07/09/2007 10:30'!
valuesAsString
	| targetStream |
	targetStream := HTTPWriteStream onByteArray: ByteArray new.
	self valuesAsStringOn: targetStream.
	^SpStringUtilities stringFromBytes: targetStream contents! !

!HeaderField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream
	^self subclassResponsibility! !

!HeaderField methodsFor: 'emitting' stamp: 'DataCurator 04/23/2007 14:43'!
writeTo: anHTTPWriteStream 
	anHTTPWriteStream
		nextPutAllCHARs: self name;
		nextPutAllCHARs: ': '.
	self writeValuesTo: anHTTPWriteStream.
	^self! !

!HeaderField methodsFor: 'emitting' stamp: 'DataCurator 04/23/2007 14:43'!
writeValuesTo: anHTTPWriteStream 
	self valuesAsStringOn: anHTTPWriteStream.
	^self! !

HeaderField subclass: #SpecificHeaderField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

SpecificHeaderField subclass: #ContentDispositionField
	instanceVariableNames: 'type parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!ContentDispositionField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Content-Disposition'! !

!ContentDispositionField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isContentDisposition
	^true! !

!ContentDispositionField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
parameterAt: aString 
	^parameters at: aString ifAbsent: [nil]! !

!ContentDispositionField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
parseValueFrom: aString 
	| sourceStream |
	sourceStream := aString readStream.
	type := SpStringUtilities trimBlanksFrom: (sourceStream upTo: $;).
	parameters := self readParametersFrom: sourceStream.
	^self! !

SpecificHeaderField subclass: #ContentTypeField
	instanceVariableNames: 'mediaType transferCodings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!ContentTypeField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Content-Type'! !

!ContentTypeField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
defaultMediaType
	"^a String
See RFC 2616 '7.2.1 Type'.  If no media type is specified, application/octet-stream is the default."

	^'application/octet-stream'! !

!ContentTypeField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isContentType
	^true! !

!ContentTypeField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
mediaType
	^mediaType isNil ifTrue: [self defaultMediaType] ifFalse: [mediaType]! !

!ContentTypeField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
mediaType: aString 
	mediaType := aString.
	^self! !

!ContentTypeField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
parseValueFrom: aString 
	| sourceStream |
	sourceStream := aString readStream.
	mediaType := (SpStringUtilities trimBlanksFrom: (sourceStream upTo: $;)).
	transferCodings := self readParametersFrom: sourceStream.
	^self! !

!ContentTypeField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
transferCodings
	transferCodings isNil ifTrue: [transferCodings := Dictionary new].
	^transferCodings! !

!ContentTypeField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: self mediaType.
	self transferCodings isEmpty 
		ifFalse: 
			[aStream
				sp.
				self transferCodings keysAndValuesDo: [:key :val |
					aStream nextPutAllCHARs: key;
						nextPutAllCHARs: '=';
						nextPutAllCHARs: val;
						nextPutAllCHARs: ';'.
				].
			].
	^self! !

SpecificHeaderField subclass: #HTTPAcceptField
	instanceVariableNames: 'mediaTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPAcceptField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Accept'! !

!HTTPAcceptField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
combineWith: aHeaderField 
	"^self
I simply take my values and concatenate the values of aHeaderField."

	self mediaTypes addAll: aHeaderField mediaTypes.
	^self! !

!HTTPAcceptField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
mediaTypes
	mediaTypes isNil ifTrue: [mediaTypes := OrderedCollection new].
	^mediaTypes! !

!HTTPAcceptField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
parseValueFrom: aString 
	mediaTypes := SpStringUtilities tokensBasedOn: ',' in: aString.
	^self! !

!HTTPAcceptField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: targetStream 
	self mediaTypes isEmpty 
		ifFalse: 
			[targetStream nextPutAllCHARs: self mediaTypes first.
			2 to: self mediaTypes size
				do: 
					[:methodIndex | 
					targetStream
						nextPutCHAR: $,;
						nextPutAllCHARs: (self mediaTypes at: methodIndex)]].
	^self! !

SpecificHeaderField subclass: #HTTPAllowField
	instanceVariableNames: 'methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPAllowField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Allow'! !

!HTTPAllowField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
methods
	methods isNil ifTrue: [methods := OrderedCollection new].
	^methods! !

!HTTPAllowField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: targetStream 
	self methods isEmpty 
		ifFalse: 
			[targetStream nextPutAllCHARs: self methods first.
			2 to: self methods size
				do: 
					[:methodIndex | 
					targetStream
						nextPutCHAR: $,;
						nextPutAllCHARs: (self methods at: methodIndex)]].
	^self! !

SpecificHeaderField subclass: #HTTPAuthorizationField
	instanceVariableNames: 'credentials'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

HTTPAuthorizationField subclass: #HTTPAuthorizationBasicField
	instanceVariableNames: 'userid password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPAuthorizationBasicField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
password
	"^a String
I return the password string (as defined in RFC 2617 pp.2) part of the user-pass value in my credentials."

	password isNil ifTrue: [self resolveUserPass].
	^password! !

!HTTPAuthorizationBasicField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
resolveUserPass
	"^self
I look at my credentials string and pull out the userid and password.  Note that having to check for atEnd before the upToEnd is for GemStone which crashes if upToEnd is used when already atEnd."

	"(Base64EncodingReadStream on: 'YnJ1Y2U6c3F1aWRzdXBwbGllZHBhc3N3b3Jk' ) upToEnd asString "

	| userPassString sourceStream |
	userPassString := SpStringUtilities 
				stringFromBytes: (Base64EncodingReadStream on: self credentials) upToEnd.
	sourceStream := ReadStream on: userPassString.
	userid := sourceStream upTo: $:.
	password := sourceStream atEnd 
				ifTrue: [String new]
				ifFalse: [sourceStream upToEnd].
	^self! !

!HTTPAuthorizationBasicField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
userid
	"^a String
I return the userid string (as defined in RFC 2617 pp.2) part of the user-pass value in my credentials."

	userid isNil ifTrue: [self resolveUserPass].
	^userid! !

!HTTPAuthorizationBasicField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: 'Basic '.
	super valuesAsStringOn: aStream.
	^self! !

HTTPAuthorizationField subclass: #HTTPAuthorizationDigestField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPAuthorizationDigestField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: 'Digest '.
	super valuesAsStringOn: aStream.
	^self! !

!HTTPAuthorizationField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Authorization'! !

!HTTPAuthorizationField class methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
newForFieldName: fieldNameString withValueFrom: fieldValueString 
	"^an HTTPAuthorizationField
I return an instance of one of my concrete subclasses.  To get to this point, the field name *must* be 'AUTHORIZATION'."

	| sourceStream schemeName |
	sourceStream := ReadStream on: fieldValueString.
	schemeName := sourceStream upTo: Character space.
	^schemeName = 'Basic' 
		ifTrue: [HTTPAuthorizationBasicField newWithValueFrom: sourceStream upToEnd]
		ifFalse: [HTTPAuthorizationDigestField newWithValueFrom: sourceStream upToEnd]! !

!HTTPAuthorizationField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
credentials
	^credentials! !

!HTTPAuthorizationField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
parseValueFrom: aString 
	credentials := SpStringUtilities trimBlanksFrom: aString.
	^self! !

!HTTPAuthorizationField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: self credentials.
	^self! !

SpecificHeaderField subclass: #HTTPCacheControlField
	instanceVariableNames: 'private maxAge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPCacheControlField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Cache-Control'! !

!HTTPCacheControlField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
directives
	1 halt: 'now, form the directives string'! !

!HTTPCacheControlField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
directives: aString 
	1 halt: 'Please set the directives you want using my service methods'.
	^self! !

!HTTPCacheControlField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
maxAge
	"^an Integer or nil
I return my max age which is either an integer number of seconds for which the entity can be considdered fresh, or nil, in which case other headers such as Expires can be used by a cache to determine the expiration time of the entity."

	^maxAge! !

!HTTPCacheControlField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
maxAge: anIntegerOrNil 
	"^self
I record the number of seconds for which the resource is 'fresh' and after which will expire and become 'stale' for caching purposes.  Setting this to nil means the max age is unspecified, and this is the default.  This directive takes presidence over any Expires header when a cache or client is handling an HTTP message."

	maxAge := anIntegerOrNil.
	^self! !

!HTTPCacheControlField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
mustRevalidate
	"^a Boolean
 If an origin server wishes to force any HTTP/1.1 cache, no matter how it is configured, to validate every request, it SHOULD use the 'must- revalidate' cache-control directive (see section 14.9).
We'll make this always false for now. "

	^false! !

!HTTPCacheControlField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
private
	"^a Boolean or nil
There are three possible values for private.  Explicity true (the entity can only be cached in private caches), explicity false (this is a public entity and can be held in a shared/public cache perhaps even when stale) or nil (the default which means that the entity may be held in a public shared cache, but only until it goes stale)."

	^private! !

!HTTPCacheControlField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
setNotPublicOrPrivate
	"^self
I am being told that the entity in my message is not explicity public or private.  This is the default and means that public caches may retain copies of the resource, but should not be as relaxed about the rules as with an explicitly public resource. c.f >>setPublic & >>setPrivate."

	private := nil.
	^self! !

!HTTPCacheControlField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
setPrivate
	"^self
I am being told that the entity in my message is a private one that can only be cached on private caches, i.e. caches that can be drawn upon a single clients.  An example of a private cache is the one *inside* your web browser.   This is probably what you want if the entity contains personal information."

	private := true.
	^self! !

!HTTPCacheControlField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
setPublic
	"^self
I am being told that the entity in my message is a public one that can be cached on public caches, i.e. caches that can be drawn upon by many clients.  This is probably not what you want if the entity contains personal information!!  c.f. >>setPrivate  Note that expicitly setting cache-control public actually loosens some other rules and means resources can be used by cached beyond their normal life."

	private := false.
	^self! !

!HTTPCacheControlField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream sp.
	self private notNil 
		ifTrue: 
			[self writePublicOrPrivateTo: aStream.
			self maxAge notNil ifTrue: [aStream nextPutAllCHARs: ', ']].
	self maxAge notNil ifTrue: [self writeMaxAgeTo: aStream].
	^self! !

!HTTPCacheControlField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
writeMaxAgeTo: aStream 
	"^self
I write the maxAge directive to aStream"

	aStream
		nextPutAllCHARs: 'max-age=';
		nextPutAllCHARs: self maxAge printString.
	^self! !

!HTTPCacheControlField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
writePublicOrPrivateTo: aStream 
	"^self
I write the either the public or the private directive to aStream"

	self private 
		ifTrue: [aStream nextPutAllCHARs: 'private']
		ifFalse: [aStream nextPutAllCHARs: 'public'].
	^self! !

SpecificHeaderField subclass: #HTTPConnectionField
	instanceVariableNames: 'connectionToken'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPConnectionField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Connection'! !

!HTTPConnectionField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
connectionToken
	"^a String
Common values are 'close' and 'keep-alive'."

	^connectionToken! !

!HTTPConnectionField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
connectionToken: aString 
	"^self"

	connectionToken := aString.
	^self! !

!HTTPConnectionField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
connectionTokenIsClose
	^self connectionToken = 'close'! !

!HTTPConnectionField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
parseValueFrom: aString 
	connectionToken := SpStringUtilities trimBlanksFrom: aString.
	^self! !

!HTTPConnectionField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
setToClose
	self connectionToken: 'close'.
	^self! !

!HTTPConnectionField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: connectionToken.
	^self! !

SpecificHeaderField subclass: #HTTPContentLengthField
	instanceVariableNames: 'contentLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPContentLengthField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Content-Length'! !

!HTTPContentLengthField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
contentLength
	^contentLength! !

!HTTPContentLengthField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
parseValueFrom: aString
	contentLength := aString asNumber.
	^self! !

!HTTPContentLengthField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: self contentLength asString.
	^self! !

SpecificHeaderField subclass: #HTTPCookieField
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPCookieField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Cookie'! !

!HTTPCookieField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
cookies
	^values! !

!HTTPCookieField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
parseValueFrom: aString
values := Dictionary new.
(aString findTokens: ';') do:
	[:each | | cookie |
	cookie := each findTokens: '='.
	(cookie size == 2 and: [cookie last isEmpty not]) ifTrue: [ values at: cookie first trimBlanks put: cookie last ]].
		! !

!HTTPCookieField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream

	(values notNil and: [values isEmpty not]) 
		ifTrue: [
			aStream nextPutAllCHARs: 'Cookie: '.
			values keysAndValuesDo: [:key :value |
				aStream nextPutAllCHARs: key;
					nextPutAllCHARs: '=';
					nextPutAllCHARs: value;
					nextPutAllCHARs: '; '.
			].
	].! !

SpecificHeaderField subclass: #HTTPDateField
	instanceVariableNames: 'date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPDateField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Date'! !

!HTTPDateField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
date
	^date! !

!HTTPDateField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
date: aDate 
	"^self
Note that this is an HTTP Date, and so is really a timestamp :-/ "

	date := aDate.
	^self! !

!HTTPDateField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: self date asRFC1123String.
	^self! !

SpecificHeaderField subclass: #HTTPETagField
	instanceVariableNames: 'entityTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPETagField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'ETag'! !

!HTTPETagField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
entityTag
	^entityTag! !

!HTTPETagField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
entityTag: aString 
	entityTag := aString.
	^self! !

!HTTPETagField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream
		nextPutCHAR: $";
		nextPutAllCHARs: self entityTag;
		nextPutCHAR: $".
	^self! !

SpecificHeaderField subclass: #HTTPHostField
	instanceVariableNames: 'hostName portNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPHostField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Host'! !

!HTTPHostField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
hostName
	^hostName! !

!HTTPHostField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
parseValueFrom: aString 
	| sourceStream portNumberString |
	sourceStream := ReadStream on: aString.
	hostName := sourceStream upTo: $:.
	portNumberString := sourceStream atEnd 
				ifTrue: [String new]
				ifFalse: [sourceStream upToEnd].
	portNumberString notEmpty 
		ifTrue: [portNumber := portNumberString asNumber].
	^self! !

!HTTPHostField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
portNumber
	^portNumber isNil ifTrue: [80] ifFalse: [portNumber]! !

!HTTPHostField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: self hostName.
	portNumber notNil 
		ifTrue: 
			[aStream
				nextPutCHAR: $:;
				nextPutAllCHARs: self portNumber printString].
	^self! !

SpecificHeaderField subclass: #HTTPIfModifiedSinceField
	instanceVariableNames: 'date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPIfModifiedSinceField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'If-Modified-Since'! !

!HTTPIfModifiedSinceField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
date
	^date! !

!HTTPIfModifiedSinceField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isCacheHitFor: anEntity 
	"^a Boolean
I return true if an anEntity is a cache hit given the conditional I represent.  So in my case, I'm looking to see that the entity has not changed since my date.
anEntity *must* respond to >>lastModified"

	^anEntity lastModified <= self date! !

!HTTPIfModifiedSinceField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isConditional
	^true! !

!HTTPIfModifiedSinceField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
parseValueFrom: aString 
	date := SpTimestamp fromRFC1123String: aString.
	^self! !

!HTTPIfModifiedSinceField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: self date asRFC1123String.
	^self! !

SpecificHeaderField subclass: #HTTPIfRangeField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPIfRangeField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'If-Range'! !

SpecificHeaderField subclass: #HTTPIfUnmodifiedSinceField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPIfUnmodifiedSinceField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'If-Unmodified-Since'! !

!HTTPIfUnmodifiedSinceField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isCacheHitFor: anEntity 
	"^a Boolean
I return true if an anEntity is a cache hit given the conditional I represent. 
anEntity *must* respond to >>entutyTag"

	1 halt.
	^self! !

!HTTPIfUnmodifiedSinceField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isConditional
	^true! !

SpecificHeaderField subclass: #HTTPLastModifiedField
	instanceVariableNames: 'date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPLastModifiedField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Last-Modified'! !

!HTTPLastModifiedField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
date
	^date! !

!HTTPLastModifiedField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
date: aDate 
	date := aDate.
	^self! !

!HTTPLastModifiedField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: self date asRFC1123String.
	^self! !

SpecificHeaderField subclass: #HTTPLocationField
	instanceVariableNames: 'uri'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPLocationField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Location'! !

!HTTPLocationField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
uri
	^uri! !

!HTTPLocationField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
uri: aSwazooURI 
	uri := aSwazooURI.
	^self! !

!HTTPLocationField methodsFor: 'accessing' stamp: 'dkh 07/09/2007 10:30'!
uriString: aString 
	uri := HyURI fromStream: (ReadStream on: aString asByteArray).
	^self! !

!HTTPLocationField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	self uri writeBytesTo: aStream.
	^self! !

SpecificHeaderField subclass: #HTTPMatchField
	instanceVariableNames: 'entityTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

HTTPMatchField subclass: #HTTPIfMatchField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPIfMatchField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'If-Match'! !

!HTTPIfMatchField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isCacheHitFor: anEntity 
	"^a Boolean
I return true if an anEntity is a cache hit given the conditional I represent. 
anEntity *must* respond to >>entutyTag"

	1 halt.
	^self! !

HTTPMatchField subclass: #HTTPIfNoneMatchField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPIfNoneMatchField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'If-None-Match'! !

!HTTPIfNoneMatchField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isCacheHitFor: anEntity 
	"^a Boolean
I return true if an anEntity is a cache hit given the conditional I represent.  So in my case, I'm looking to see that the entity has a tag which is in my collection of entityTags.
anEntity *must* respond to >>entityTag"

	^self entityTags includes: anEntity entityTag! !

!HTTPMatchField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
addEntityTag: aString 
	self entityTags add: aString.
	^self! !

!HTTPMatchField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
combineWith: aHeaderField 
	"^self
I add the entity tags of aHeaderField to my own collection of entity tags."

	self entityTags addAll: aHeaderField entityTags.
	^self! !

!HTTPMatchField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
entityTags
	^self matchesAnyCurrentEntity 
		ifTrue: [nil]
		ifFalse: 
			[entityTags isNil ifTrue: [entityTags := OrderedCollection new].
			entityTags]! !

!HTTPMatchField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isConditional
	^true! !

!HTTPMatchField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
matchesAnyCurrentEntity
	^entityTags = '*'! !

!HTTPMatchField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
parseValueFrom: aString 
	aString = '*' 
		ifTrue: [entityTags := aString]
		ifFalse: 
			[| sourceStream |
			entityTags := OrderedCollection new.
			sourceStream := ReadStream on: aString.
			[sourceStream atEnd] whileFalse: 
					[| entityTag |
					sourceStream upTo: $".
					entityTag := sourceStream upTo: $".
					entityTags add: entityTag.
					sourceStream upTo: $,]].
	^self! !

!HTTPMatchField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: targetStream 
	self write: self entityTags first asQuotedStringTo: targetStream.
	2 to: self entityTags size
		do: 
			[:tagIndex | 
			targetStream nextPutCHAR: $,.
			self write: (self entityTags at: tagIndex) asQuotedStringTo: targetStream].
	^self! !

!HTTPMatchField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
write: aString asQuotedStringTo: targetStream 
	"^self
See RFC 2616 2.2"

	targetStream nextPutCHAR: $".
	aString do: 
			[:character | 
			character == $" 
				ifTrue: [targetStream nextPutAllCHARs: '\"']
				ifFalse: [targetStream nextPutCHAR: character]].
	targetStream nextPutCHAR: $".
	^self! !

SpecificHeaderField subclass: #HTTPRefererField
	instanceVariableNames: 'uri'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPRefererField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Referer'! !

!HTTPRefererField methodsFor: 'private' stamp: 'dkh 07/09/2007 10:30'!
parseValueFrom: aString 
	"^an HyURI
I return a URI parsed from aString.  URIs really prefer to parse byte streams.  For now, I just convert the string to a ByteArray and wrap a stream around it."

	uri := HyURI fromStream: (ReadStream on: aString asByteArray).
	^self! !

!HTTPRefererField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
uri
	^uri! !

!HTTPRefererField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	self uri writeBytesTo: aStream.
	^self! !

SpecificHeaderField subclass: #HTTPServerField
	instanceVariableNames: 'productTokens'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPServerField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Server'! !

!HTTPServerField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
productTokens
	^productTokens! !

!HTTPServerField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
productTokens: aString 
	productTokens := aString.
	^self! !

!HTTPServerField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: self productTokens.
	^self! !

SpecificHeaderField subclass: #HTTPSetCookieField
	instanceVariableNames: 'cookies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPSetCookieField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Set-Cookie'! !

!HTTPSetCookieField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
addCookie: aCookieString
	^self cookies add: aCookieString! !

!HTTPSetCookieField methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
combineWith: aSetCookieField 
	"^self
I add the cookies of aSetCookieField to my own collection of cookies."

	self cookies addAll: aSetCookieField cookies.
	^self! !

!HTTPSetCookieField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
cookies
	cookies isNil ifTrue: [cookies := OrderedCollection new].
	^cookies! !

!HTTPSetCookieField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: (self cookies at: 1).
	2 to: self cookies size
		do: 
			[:cookieIndex | 
			aStream
				nextPutAllCHARs: ', ';
				nextPutAllCHARs: (self cookies at: cookieIndex)].
	^self! !

SpecificHeaderField subclass: #HTTPTransferEncodingField
	instanceVariableNames: 'transferEncoding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPTransferEncodingField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'Transfer-Encoding'! !

!HTTPTransferEncodingField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isTransferEncoding
	^true! !

!HTTPTransferEncodingField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
parseValueFrom: aString 
	transferEncoding := SpStringUtilities trimBlanksFrom: aString! !

!HTTPTransferEncodingField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
transferEncoding
	^transferEncoding! !

!HTTPTransferEncodingField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
transferEncoding: aString
	transferEncoding := aString! !

!HTTPTransferEncodingField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: self transferEncoding.
	^self! !

SpecificHeaderField subclass: #HTTPUserAgentField
	instanceVariableNames: 'productTokens'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPUserAgentField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'User-Agent'! !

!HTTPUserAgentField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
parseValueFrom: aString 
	"^self
I could try and parse out the product name and version numbers, but there is no need to worry about this at the moment, so I just record the string."

	productTokens := SpStringUtilities trimBlanksFrom: aString.
	^self! !

!HTTPUserAgentField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
productTokens
	^productTokens! !

!HTTPUserAgentField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream nextPutAllCHARs: productTokens.
	^self! !

SpecificHeaderField subclass: #HTTPWWWAuthenticateField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

HTTPWWWAuthenticateField subclass: #HTTPWWWAuthenticateBasicField
	instanceVariableNames: 'realm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPWWWAuthenticateBasicField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isBasic
	"^a Boolean
I return true if I represent a header for basic authentication. c.f. RFC 2617 sec 2."

	^true! !

!HTTPWWWAuthenticateBasicField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
realm
	"^a String
I return the realm for which I represent an autentication challenge.  This string will be presented to the browser user in the login dialog."

	^realm! !

!HTTPWWWAuthenticateBasicField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
realm: anObject
	realm := anObject! !

!HTTPWWWAuthenticateBasicField methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
valuesAsStringOn: aStream 
	aStream
		nextPutAllCHARs: 'Basic realm="';
		nextPutAllCHARs: self realm;
		nextPutCHAR: $".
	^self! !

HTTPWWWAuthenticateField subclass: #HTTPWWWAuthenticateDigestField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPWWWAuthenticateDigestField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isDigest
	"^a Boolean
I return true if I represent a header for digest authentication. c.f. RFC 2617 sec 3."

	^true! !

!HTTPWWWAuthenticateField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^'WWW-Authenticate'! !

!HTTPWWWAuthenticateField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isBasic
	"^a Boolean
I return true if I represent a header for basic authentication. c.f. RFC 2617 sec 2."

	^false! !

!HTTPWWWAuthenticateField methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isDigest
	"^a Boolean
I return true if I represent a header for digest authentication. c.f. RFC 2617 sec 3."

	^false! !

!SpecificHeaderField class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
fieldName
	^self subclassResponsibility! !

!SpecificHeaderField class methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
newForFieldName: fieldNameString withValueFrom: fieldValueString 
	^self newWithValueFrom: fieldValueString! !

!SpecificHeaderField class methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
newWithValueFrom: fieldValueString 
	^self new valueFrom: fieldValueString! !

!SpecificHeaderField methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
name
	^self class fieldName! !

!SpecificHeaderField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
parseValueFrom: aString
	^self subclassResponsibility! !

!SpecificHeaderField methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
readParametersFrom: sourceStream 
	"^a Dictionary
c.f. RFC 2616 3.6 Transfer Codings"

	| parameters |
	parameters := Dictionary new.
	[sourceStream atEnd] whileFalse: 
			[| attribute value |
			attribute := SpStringUtilities trimBlanksFrom: (sourceStream upTo: $=).
			value := SpStringUtilities trimBlanksFrom: (sourceStream upTo: $;).
			parameters at: attribute put: value].
	^parameters! !

!SpecificHeaderField methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
valueFrom: fieldValueString 
	self parseValueFrom: fieldValueString.
	^self! !

Object subclass: #HTTPFirstLine
	instanceVariableNames: 'httpVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPFirstLine class methodsFor: 'instance creation' stamp: 'DataCurator 04/23/2007 14:43'!
readFrom: aStream 
	"^an HTTPFirstLine
I return a new instance of one of my subclasses which represents the first line of a request or response read from aStream."

	^self new readFrom: aStream! !

!HTTPFirstLine methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
httpVersion
	^httpVersion! !

!HTTPFirstLine methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
httpVersion: anArray 
	httpVersion := anArray.
	^self! !

!HTTPFirstLine methodsFor: 'parsing' stamp: 'DataCurator 04/23/2007 14:43'!
parseHTTPVersionFrom: byteStream 
	"^self
I read the HTTP version from the byteStream.  This is the same for a Request-Line of a Request (c.f. RFC 2616 5.1.2) and the Status-Line of a Response (c.f. RFC 2616 6.2).  The exact format of the HTTP version is defined in RFC 2626 pp3.1, and is: 'HTTP' '/' 1*DIGIT '.' 1*DIGIT "

	| major minor |
	(byteStream nextCHARs: 5) = 'HTTP/' 
		ifFalse: 
			[HyHTTPParseError 
				raiseSignal: 'HTTP Version malformed.  No leading "HTTP/".'].
	major := (byteStream nextCHARs: 1) asNumber.
	byteStream next.
	minor := (byteStream nextCHARs: 1) asNumber.
	self httpVersion: (Array with: major with: minor).
	^self! !

!HTTPFirstLine methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
readFrom: sourceStream 
	^self subclassResponsibility! !

!HTTPFirstLine methodsFor: 'parsing' stamp: 'DataCurator 04/23/2007 14:43'!
skipLeadingBlankLinesIn: aStream 
	"^self
RFC 2616:
In the interest of robustness, servers SHOULD ignore any empty
line(s) received where a Request-Line is expected. In other words, if
the server is reading the protocol stream at the beginning of a
message and receives a CRLF first, it should ignore the CRLF."

	[aStream peekCHAR == Character cr] whileTrue: 
			[((aStream nextCHARs: 2) at: 2 == Character lf) 
				ifFalse: [HyHTTPParseError raiseSignal: 'CR without LF']].
	^self! !

HTTPFirstLine subclass: #HTTPRequestLine
	instanceVariableNames: 'method requestURI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPRequestLine methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
method
	^method! !

!HTTPRequestLine methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
method: aString
"For development testing only"
	method := aString.
	^self! !

!HTTPRequestLine methodsFor: 'parsing' stamp: 'dkh 07/09/2007 10:30'!
parseURIFrom: sourceStream 
	"^self
I parse the URI from the sourceStream.  It is the HTTP RFC that specifies that the URI on a request line is terminated with an SP (space - integer value 32) so I pull that from the sourceStream.  I then have the HyURI class parse the URO from that ByteArray.  c.f. RFC2616 pp 5.1.2 "

	| uriBytes |
	uriBytes := sourceStream upTo: Character space asInteger.
	requestURI := HyURI fromStream: (ReadStream on: uriBytes).
	^self! !

!HTTPRequestLine methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
readFrom: sourceStream 
	"^self
I initialize myself to represents a request line read from aStream.  If no valid request line can be found, I throw an exception."

	self skipLeadingBlankLinesIn: sourceStream.
	method := sourceStream nextCHARsUpToCHAR: Character space.
	self parseURIFrom: sourceStream.
	self parseHTTPVersionFrom: sourceStream.
	self skipTrailingCRLFFrom: sourceStream.
	^self! !

!HTTPRequestLine methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
requestURI
	^requestURI! !

!HTTPRequestLine methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
requestURI: aString 
	"Development testing only!!"

	requestURI := aString.
	^self! !

!HTTPRequestLine methodsFor: 'parsing' stamp: 'DataCurator 04/23/2007 14:43'!
skipTrailingCRLFFrom: sourceStream 
	"^self
I skip over the CRLF that terminates this request line in the source stream.  For now I'll assume that the next two characters are a cr followed by an lf.  In the future I may check."

	sourceStream
		next;
		next.
	^self! !

HTTPFirstLine subclass: #HTTPStatusLine
	instanceVariableNames: 'statusCode reasonPhrase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPStatusLine methodsFor: 'parsing' stamp: 'DataCurator 04/23/2007 14:43'!
parseHTTPMinorVersionFrom: byteStream 
	| minor |
	minor := (byteStream nextCHARsUpToCHAR: Character space) asNumber.
	^minor! !

!HTTPStatusLine methodsFor: 'parsing' stamp: 'DataCurator 04/23/2007 14:43'!
parseReasonPhraseFrom: sourceStream 
	"^self
I parse the reason phrase from the byteStream.  I am positioned at the first character of the reason phrase and I read up to the CRLF terminator ... well, I read up to the cr and then skip the lf."

	reasonPhrase := sourceStream nextCHARsUpToCHAR: Character cr.
	sourceStream next.
	^self! !

!HTTPStatusLine methodsFor: 'parsing' stamp: 'DataCurator 04/23/2007 14:43'!
parseStatusCodeFrom: sourceStream 
	statusCode := sourceStream nextCHARsUpToCHAR: Character space.
	^self! !

!HTTPStatusLine methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
readFrom: sourceStream 
	"^self
I initialize myself to represents an HTTP response status line (c.f. RFC 2616 6.1) read from aStream."

	self skipLeadingBlankLinesIn: sourceStream.
	self parseHTTPVersionFrom: sourceStream.
	sourceStream next.
	self parseStatusCodeFrom: sourceStream.
	self parseReasonPhraseFrom: sourceStream.
	^self! !

!HTTPStatusLine methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
reasonPhrase
	"^a String
I return my reasonPhrase.  See RFC 2616 6.1.1 for the full list of reason phrases."

	^reasonPhrase! !

!HTTPStatusLine methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
statusCode
	"^a String
I return my status code.  See RFC 2616 6.1.1 for the full list of status codes.  This is a String rather than a integer because that's the form it's needed in.  It never gets used as a magnitude or number."

	^statusCode! !

Object subclass: #HTTPHeaders
	instanceVariableNames: 'fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPHeaders class methodsFor: 'instance creation' stamp: 'DataCurator 04/23/2007 14:43'!
readFrom: aStream 
	"^an HTTPHeaders
I return a new instance of myself which contains fields parsed from aStream."

	^self new readFrom: aStream! !

!HTTPHeaders methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
addField: aField 
	"HTTPSpec1.1 Sec4.2
Multiple message-header fields with the same field-name MAY be present in a message if and only if the entire field-value for that header field is defined as a comma-separated list [i.e., #(values)]. It MUST be possible to combine the multiple header fields into one 'field-name: field-value' pair, without changing the semantics of the message, by appending each subsequent field-value to the first, each separated by a comma. The order in which header fields with the same field-name are received is therefore significant to the interpretation of the combined field value, and thus a proxy MUST NOT change the order of these field values when a message is forwarded.
Note that we have to use the field name here as we may be adding a field for which there is no class, i.e. it's a GenericHeaderField."

	(self includesFieldNamed: aField name) 
		ifTrue: [(self fieldNamed: aField name) combineWith: aField]
		ifFalse: [self fields at: aField name asUppercase put: aField].
	^self! !

!HTTPHeaders methodsFor: 'emitting' stamp: 'DataCurator 04/23/2007 14:43'!
crlfOn: aStream 
	aStream
		nextPut: Character cr;
		nextPut: Character lf! !

!HTTPHeaders methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
fieldNamed: aString 
	"^aString
If I contain a field named aString, I return it.  Otherwise an exception is thrown.
This is a bad way of getting a field.  Use >> fieldOfClass: instead."

	| targetString |
	targetString := aString asUppercase.
	^self fields detect: [:aField | aField name asUppercase = targetString]! !

!HTTPHeaders methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
fieldNamed: aString ifNone: aBlock 
	"^aString
If I contain a field named aString, I return it.  Otherwise I evaluate aBlock."

	^self fields at: aString asUppercase ifAbsent: aBlock! !

!HTTPHeaders methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
fieldNamed: aFieldName ifPresent: presentBlock ifAbsent: absentBlock 
	"^an Object
I look for a field named aFieldName among my fields.  If I find it, I return the result of evaluating presentBlock with the found field as an argument, otherwise I return the result of evaluate the absentBlock"

	| foundField |
	foundField := self fieldNamed: aFieldName ifNone: [nil].
	^foundField isNil 
		ifTrue: [absentBlock value]
		ifFalse: [presentBlock value: foundField]! !

!HTTPHeaders methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
fieldOfClass: aClass 
	"^aString
If I contain a field of class aClass, I return it.   Otherwise an exception is thrown."

	^self fields detect: [:aField | aField class == aClass]! !

!HTTPHeaders methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
fieldOfClass: aClass ifNone: aBlock 
	"^aString
If I contain a field of class aClass, I return it.   Otherwise I evaluate aBlock."

	^self fields detect: [:aField | aField class == aClass] ifNone: aBlock! !

!HTTPHeaders methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
fieldOfClass: fieldClass ifPresent: presentBlock ifAbsent: absentBlock 
	"^an Object
I look for a field of class fieldClass among my fields.  If I find it, I return the result of evaluating presentBlock with the found field as an argument, otherwise I return the result of evaluate the absentBlock"

	| foundField |
	foundField := self fieldOfClass: fieldClass ifNone: [nil].
	^foundField isNil 
		ifTrue: [absentBlock value]
		ifFalse: [presentBlock value: foundField]! !

!HTTPHeaders methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
fields
	fields isNil ifTrue: [fields := Dictionary new].
	^fields! !

!HTTPHeaders methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
getOrMakeFieldOfClass: aClass 
	"^a HeaderField
If I contain a field of class aClass, I return it.   Otherwise I create a new instance if the field class and add it to my collection of headers."

	^self fieldOfClass: aClass
		ifNone: 
			[| newField |
			newField := aClass new.
			self addField: newField.
			newField]! !

!HTTPHeaders methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
includesFieldNamed: aString 
	"^a Boolean
I return true if one of my fields has the name aString."

	| targetField |
	targetField := self fieldNamed: aString ifNone: [nil].
	^targetField notNil! !

!HTTPHeaders methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
includesFieldOfClass: aClass 
	"^a Boolean
I return true if one of my fields is of class aClass."

	^self 
		fieldOfClass: aClass
		ifPresent: [:aField | true]
		ifAbsent: [false]! !

!HTTPHeaders methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
keysAndValuesDo: aBlock

 self fields keysAndValuesDo: aBlock! !

!HTTPHeaders methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
readFieldFromString: aString 
	"^self
First I get the field parsed from aString, then I add the new field to my collection of fields.  Adding the new field may involve merging field values if I already have a field of that class."

	self addField: (HeaderField fromLine: aString).
	^self! !

!HTTPHeaders methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
readFrom: aStream 
	"^an HTTPHeaders
I return a new instance of myself which contains fields parsed from aStream.  Everything upto the next blank line is a header field."

	
	[| nextLineString |
	nextLineString := aStream nextUnfoldedLine.
	nextLineString isEmpty 
		ifTrue: [true]
		ifFalse: 
			[self readFieldFromString: nextLineString.
			false]] 
			whileFalse: [].
	^self! !

!HTTPHeaders methodsFor: 'emitting' stamp: 'DataCurator 04/23/2007 14:43'!
writeOn: aStream 
	"^self
I write all my fields to aStream."

	self fields do: 
			[:aField | 
			aField printOn: aStream.
			self crlfOn: aStream]! !

Object subclass: #HTTPMessage
	instanceVariableNames: 'headers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPMessage methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
addHeaderName: aName value: aValue 

  self headers addField: (GenericHeaderField newForFieldName: aName withValueFrom: aValue).
  ^self! !

!HTTPMessage methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
addInitialHeaders
	"^self 
This is a no-op.  My subclasses may wish to add some initial headers."

	^self! !

!HTTPMessage methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
headers
	headers isNil 
		ifTrue: 
			[headers := HTTPHeaders new.
			self addInitialHeaders].
	^headers! !

HTTPMessage subclass: #HTTPRequest
	instanceVariableNames: 'requestLine peer timestamp ip environmentData resolution encrypted authenticated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

HTTPRequest class
	instanceVariableNames: 'httpMethodToClassDictionary'!

HTTPRequest subclass: #HTTPDelete
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPDelete class methodsFor: 'accessing' stamp: 'topa 03/26/2009 11:26'!
methodName
	^ 'DELETE'! !

!HTTPDelete methodsFor: 'testing' stamp: 'topa 03/26/2009 11:27'!
isDelete
	^ true! !

HTTPRequest subclass: #HTTPGet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPGet class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
methodName
	^'GET'! !

!HTTPGet methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isGet
	^true! !

HTTPRequest subclass: #HTTPHead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPHead class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
methodName
	^'HEAD'! !

!HTTPHead methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isHead
	^true! !

HTTPRequest subclass: #HTTPOptions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPOptions class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
methodName
	^'OPTIONS'! !

!HTTPOptions methodsFor: 'services' stamp: 'dkh 07/09/2007 10:30'!
respondUsing: responseBlock 
	"^an HTTPResponse
I represent a request for the options supported by this server.  I respond with a 200 (OK) and a list of my supported methods in an Allow: header.  I ignore the responseBlock."

	| response allowField |
	response := HTTPResponse ok.
	allowField := HTTPAllowField new.
	allowField methods addAll: self class httpMethodToClassDictionary keys.
	response headers addField: allowField.
	^response! !

HTTPRequest subclass: #HTTPPost
	instanceVariableNames: 'postData entityBody'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPPost class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
methodName
	^'POST'! !

!HTTPPost methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
applicationOctetStreamFrom: aStream 
	"^self 
rfc 2046 says:
The recommended action for an implementation that receives an 'application/octet-stream' entity is to simply offer to put the data in a file, with any Content-Transfer-Encoding undone, or perhaps to use it as input to a user-specified process."

	self entityBody: (SpStringUtilities 
				stringFromBytes: (aStream next: self contentLength)).
	^self! !

!HTTPPost methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
emptyData
	^self postData select: [:each | each value isEmpty]! !

!HTTPPost methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
entityBody
	^entityBody! !

!HTTPPost methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
entityBody: aString
	entityBody := aString! !

!HTTPPost methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
for: aRequestLine readFrom: aStream 
	| mediaType |
	super for: aRequestLine readFrom: aStream.
	((self headers includesFieldOfClass: ContentTypeField) 
		and: [self headers includesFieldOfClass: HTTPContentLengthField]) 
			ifFalse: 
				[^HyHTTPPostError 
					raiseSignal: 'Both Content-Type and Content-Length needed'].
	mediaType := (self headers fieldOfClass: ContentTypeField) mediaType.
	mediaType = 'application/x-www-form-urlencoded' 
		ifTrue: [^self urlencodedDataFrom: aStream].
	mediaType = 'multipart/form-data' 
		ifTrue: [^self multipartDataFrom: aStream].
	self applicationOctetStreamFrom: aStream! !

!HTTPPost methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isPost
	^true! !

!HTTPPost methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
multipartDataFrom: aStream 
	| e tokens boundary contentTypeField |
	self headers fieldOfClass: HTTPContentLengthField
		ifNone: [^HyHTTPPostError raiseSignal: 'Content-Length header missing'].
	e := aStream next: self contentLength.
	contentTypeField := self headers fieldOfClass: ContentTypeField
				ifNone: [^self].
	boundary := contentTypeField transferCodings at: 'boundary'
				ifAbsent: [^self].
	tokens := self tokensIn: e BasedOnAll: boundary asByteArray.
	tokens do: 
			[:bytes | 
			| part |
			part := self partFromBytes: bytes.
			part isNil ifFalse: [self postData at: part key put: part value]]! !

!HTTPPost methodsFor: 'private' stamp: 'dkh 07/09/2007 10:30'!
partFromBytes: bytes 
	| str rs name datum |
	str := SpStringUtilities trimBlanksFrom: (SpStringUtilities stringFromBytes: bytes).
	str = '--' ifTrue: [^nil].
	rs := str readStream.
	name := nil.
	datum := HTTPPostDatum new.
	[rs atEnd] whileFalse: 
			[| line |
			line := rs upTo: Character cr.
			rs peek = Character lf 
				ifTrue: 
					[| field |
					rs next.
					line isEmpty 
						ifTrue: 
							[| entity |
							name isNil ifTrue: [^nil].
							entity := rs upToEnd.
							entity size <= 4 
								ifTrue: [datum value: entity species new]
								ifFalse: [datum value: (entity copyFrom: 1 to: entity size - 4)].
							^name -> datum].
					field := HeaderField fromLine: line.
					field isContentDisposition 
						ifTrue: [ | filename |
							name := (field parameterAt: 'name') copyWithout: $".
						
							filename := field parameterAt: 'filename'.
							filename ~~ nil 
								ifTrue: [ datum filename: (filename copyWithout: $") ].
						].
					field isContentType ifTrue: [datum contentType: field mediaType]]]! !

!HTTPPost methodsFor: 'private' stamp: 'dkh 07/09/2007 10:30'!
postData
	postData isNil ifTrue: [postData := HTTPPostDataArray new].
	^postData! !

!HTTPPost methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
postDataAt: aKey 
	^self postDataAt: aKey ifAbsent: [nil]! !

!HTTPPost methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
postDataAt: aKey do: aBlock 
	| val |
	val := self postData at: aKey ifAbsent: [nil].
	val isNil ifFalse: [aBlock value: val]! !

!HTTPPost methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
postDataAt: aKey ifAbsent: aBlock 
	^self postData at: aKey ifAbsent: aBlock! !

!HTTPPost methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
postDataAt: aKey put: aPostDatum 
	"for testing purposes"

	self postData at: aKey put: aPostDatum! !

!HTTPPost methodsFor: 'accessing' stamp: 'dkh 07/09/2007 10:30'!
postDataAt: aKey putString: aString 
	"for testing purposes"

	self postDataAt: aKey put: (HTTPPostDatum new value: aString)! !

!HTTPPost methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
postDataKeys
	^self postData keys! !

!HTTPPost methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
postDataStringAt: aKey 
	^(self postDataAt: aKey ifAbsent: [^nil]) value! !

!HTTPPost methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
postKeysAndValuesDo: aTwoArgBlock 
	self postData 
		keysAndValuesDo: [:key :each | aTwoArgBlock value: key value: each value]! !

!HTTPPost methodsFor: 'printing' stamp: 'dkh 11/26/2007 14:49'!
printOn: aStream

	super printOn: aStream.
	aStream cr.
	aStream nextPutAll: 'PostData {'.
	self postData postKeysAndValuesDo: [:key :value |
		aStream nextPutAll: key; nextPutAll: '->'.
		value filename ~~ nil ifTrue: [ aStream nextPutAll: '{filename=', value filename, '}'].
		aStream nextPutAll: value value.
		aStream cr.
	].
	aStream nextPutAll: '}'; cr.! !

!HTTPPost methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
tokensIn: aSourceCollection BasedOnAll: aSequenceableCollection 
	"Answer an OrderedCollection of the sub-sequences
	 of the receiver that are separated by aSequenceableCollection."

	| tokenPosition sourcePosition targetCollection |
	sourcePosition := 1.
	targetCollection := OrderedCollection new.
	
	[tokenPosition := aSourceCollection 
				indexOfSubCollection: aSequenceableCollection
				startingAt: sourcePosition.
	tokenPosition = 0] 
			whileFalse: 
				[targetCollection 
					add: (aSourceCollection copyFrom: sourcePosition to: tokenPosition - 1).
				sourcePosition := tokenPosition + aSequenceableCollection size].
	targetCollection 
		add: (aSourceCollection copyFrom: sourcePosition to: aSourceCollection size).
	^targetCollection! !

!HTTPPost methodsFor: 'private' stamp: 'dkh 07/09/2007 10:30'!
urlencodedDataFrom: byteStream 
	| entity tokens |
	(self headers includesFieldOfClass: HTTPContentLengthField) 
		ifFalse: [^self].
	entity := byteStream next: self contentLength.
	tokens := SpStringUtilities tokensBasedOn: '&'
				in: (SpStringUtilities stringFromBytes: entity).
	(tokens collect: [:each | SpStringUtilities tokensBasedOn: '=' in: each]) 
		do: 
			[:keyVal | 
			| datum |
			datum := HTTPPostDatum new.
			datum 
				value: (HyURI decodedHTTPFrom: (keyVal last 
								collect: [:char | char = $+ ifTrue: [Character space] ifFalse: [char]])).
			self postDataAt: keyVal first put: datum]! !

HTTPRequest subclass: #HTTPPut
	instanceVariableNames: 'putData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPPut class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
methodName
	^'PUT'! !

!HTTPPut methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
for: aRequestLine readFrom: aStream 
	| contentTypeField |
	super for: aRequestLine readFrom: aStream.
	contentTypeField := self headers fieldOfClass: ContentTypeField
				ifNone: [ ^self octetDataFrom: aStream ].
	contentTypeField mediaType = 'application/octet-stream' 
		ifTrue: [self octetDataFrom: aStream]
		ifFalse: [self urlencodedDataFrom: aStream].
	^self! !

!HTTPPut methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isPut
	^true! !

!HTTPPut methodsFor: 'reading' stamp: 'DataCurator 04/23/2007 14:43'!
octetDataFrom: aStream 
	self headers fieldOfClass: HTTPContentLengthField
		ifNone: [^HyHTTPPutError raiseSignal: 'Missing Content-Length'].
	self putData: (SpStringUtilities stringFromBytes: (aStream next: self contentLength))! !

!HTTPPut methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
putData
	^putData! !

!HTTPPut methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
putData: aString
	putData := aString! !

!HTTPPut methodsFor: 'reading' stamp: 'topa 03/26/2009 11:39'!
readFrom: aStream 
	self octetDataFrom: aStream.
	^self! !

!HTTPRequest class methodsFor: 'private' stamp: 'topa 03/26/2009 11:29'!
httpMethodToClassDictionary
	"^a Class
I return the dictionarry of my subclasses keyed on the name of the method they handle."

	"HTTPRequest resetHttpMethodToClassDictionary"

	httpMethodToClassDictionary isNil 
		ifTrue: 
			[| requestClasses |
			requestClasses := (OrderedCollection new: 5)
						add: HTTPGet;
						add: HTTPHead;
						add: HTTPOptions;
						add: HTTPPost;
						add: HTTPPut;
						add: HTTPDelete;
						yourself.
			httpMethodToClassDictionary := Dictionary new.
			requestClasses do: 
					[:aRequestClass | 
					httpMethodToClassDictionary at: aRequestClass methodName put: aRequestClass]].
	^httpMethodToClassDictionary! !

!HTTPRequest class methodsFor: 'initialization' stamp: 'DataCurator 04/23/2007 14:43'!
initialize
	"HTTPRequest initialize"

self httpMethodToClassDictionary! !

!HTTPRequest class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
methodName
	^self subclassResponsibility! !

!HTTPRequest class methodsFor: 'private' stamp: 'dkh 07/09/2007 10:30'!
newFor: aRequestLine readFrom: aStream 
	| targetClass |
	targetClass := self httpMethodToClassDictionary at: aRequestLine method
				ifAbsent: [HTTPUnsupported].
	^targetClass new for: aRequestLine readFrom: aStream! !

!HTTPRequest class methodsFor: 'instance creation' stamp: 'DataCurator 04/23/2007 14:43'!
readFrom: sourceStream 
	"^an HTTPRequest
I create and return a new instance of one of my subclasses which will represent the HTTP request presumed to be the contents of aStream.
The first step is to work out which of my subclasses to create.  I do this by parsing the 'request-line' from the stream.  The request-line contains the 'method', and I look for the subclass that handles this method and delegate the rest of the message parsing to a new instance of that class."

	| requestLine |
	requestLine := HTTPRequestLine readFrom: sourceStream.
	^self newFor: requestLine readFrom: sourceStream! !

!HTTPRequest class methodsFor: 'testing support' stamp: 'DataCurator 04/23/2007 14:43'!
request: aUriString 
	"For testing only (I'm guessing / hoping!!).  The idea to to create a request for a resource with the URI 'someHost/aUriString'."

	^self 
		request: aUriString
		from: 'someHost'
		at: 'someIP'! !

!HTTPRequest class methodsFor: 'testing support' stamp: 'DataCurator 04/23/2007 14:43'!
request: aUriString from: aHostString at: anIPString 
	"For testing only (I'm guessing / hoping!!).
A request is manufactured that has a request line method of >>methodName and a request line URI with an identifier of aUriString.  A Host header is added to the headers and the ip address is set to anIP string.
This may result in a corrupt or invalid request, but that's the natutre of testing, I guess."

	^self new 
		request: aUriString
		from: aHostString
		at: anIPString! !

!HTTPRequest class methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
resetHttpMethodToClassDictionary
	httpMethodToClassDictionary := nil.
	^self! !

!HTTPRequest methodsFor: 'private-accessing' stamp: 'DataCurator 04/23/2007 14:43'!
authenticated
	^authenticated! !

!HTTPRequest methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
conditionalHeaderFields
	"^an OrderedCollection
I return my collection of conditional header fields.  A conditional GET requires that each of these is checked against the current state of the target resource."

	^self headers fields select: [:aField | aField isConditional]! !

!HTTPRequest methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
connection
	^(self headers fieldOfClass: HTTPConnectionField ifNone: [^nil]) 
		connectionToken! !

!HTTPRequest methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
contentLength
	^(self headers fieldOfClass: HTTPContentLengthField) contentLength! !

!HTTPRequest methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
cookie
	| field |
	field := self headers fieldOfClass: HTTPCookieField ifNone: [nil].
	^field isNil ifTrue: [nil] ifFalse: [field valuesAsString]! !

!HTTPRequest methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
cookies
	| field |
	field := self headers fieldOfClass: HTTPCookieField ifNone: [nil].
	^field isNil ifTrue: [Dictionary new] ifFalse: [field cookies]! !

!HTTPRequest methodsFor: 'private-accessing' stamp: 'DataCurator 04/23/2007 14:43'!
encrypted
	^encrypted! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
environmentAt: aKey 
	^self environmentAt: aKey ifAbsent: [nil]! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
environmentAt: aKey ifAbsent: aBlock 
	^self environmentData at: aKey ifAbsent: aBlock! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
environmentAt: aKey put: aValue 
	self environmentData at: aKey put: aValue! !

!HTTPRequest methodsFor: 'private-accessing' stamp: 'DataCurator 04/23/2007 14:43'!
environmentData
	environmentData isNil ifTrue: [environmentData := Dictionary new].
	^environmentData! !

!HTTPRequest methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
for: aRequestLine readFrom: aStream 
	"^self
I parse my headers from aStream and update my URI and HTTP version information from aRequest line.  I need to parse the headers first because, for some reason, the URI insists on knowing the host, and this is taken from the Host: header field."

	requestLine := aRequestLine.
	headers := HTTPHeaders readFrom: aStream.
	^self! !

!HTTPRequest methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
hasCookie
	"check if  Cookie:  was in request header"

	^self headers includesFieldOfClass: HTTPCookieField! !

!HTTPRequest methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
host
	^(self headers fieldOfClass: HTTPHostField ifNone: [^String new]) 
		hostName! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
httpVersion
	^self requestLine httpVersion! !

!HTTPRequest methodsFor: 'accessing-queries' stamp: 'DataCurator 04/23/2007 14:43'!
includesQuery: aString 
	^self uri includesQuery: aString! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
ip
	^ip! !

!HTTPRequest methodsFor: 'private-accessing' stamp: 'DataCurator 04/23/2007 14:43'!
ip: anObject
	ip := anObject! !

!HTTPRequest methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isAuthenticated
	^self authenticated isNil not! !

!HTTPRequest methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isClose
	| connectionField |
	connectionField := self headers fieldOfClass: HTTPConnectionField
				ifNone: [nil].
	^connectionField notNil and: [connectionField connectionTokenIsClose]! !

!HTTPRequest methodsFor: 'testing' stamp: 'topa 03/26/2009 11:27'!
isDelete
	^ false! !

!HTTPRequest methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isEncrypted
	^self encrypted isNil not! !

!HTTPRequest methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isGet
	^false! !

!HTTPRequest methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isHead
	^false! !

!HTTPRequest methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isKeepAlive
	| header |
	header := self connection.
	header isNil ifTrue: [^false].
	^ SpStringUtilities string: self connection matches: #( $* 'Keep-Alive' $* )! !

!HTTPRequest methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isPost
	^false! !

!HTTPRequest methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isPut
	^false! !

!HTTPRequest methodsFor: 'private' stamp: 'dkh 07/09/2007 10:30'!
linesFrom: aStream 
	| lines lineStream line |
	lines := OrderedCollection new.
	lineStream := HTTPReadStream onStream: aStream.
	
	[line := lineStream nextLine.
	line isEmpty] whileFalse: [lines add: line].
	^lines! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
method
"It appears that it is only important to get the isGet answer correct ... based on usage in Seaside"

self isGet ifTrue: [^'GET'].
self isPut ifTrue: [^'PUT'].
^'???'! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
peer
	^peer! !

!HTTPRequest methodsFor: 'private-accessing' stamp: 'DataCurator 04/23/2007 14:43'!
peer: anObject
	peer := anObject! !

!HTTPRequest methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
port
	"^an Integer
I return the port number to which the request was directed.

Need to be compatible with Squeak therefore poorly formed 1.0 requests must be handled"

	| p |
	p := (self headers fieldOfClass: HTTPHostField) portNumber.
	p ~~ nil ifTrue: [ ^p ].
	"try the requestline"
	^self requestLine requestURI port! !

!HTTPRequest methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
printOn: aStream 
	aStream nextPutAll: 'an ', self class name.
	self peer isNil 
		ifFalse: 
			[aStream
				nextPutAll: ' from: ';
				nextPutAll: self peer].
	aStream nextPutAll: ' at: '.
	self timestamp asRFC1123StringOn: aStream.
	aStream
		nextPutAll: ' url: '.
	self uri printOn: aStream.
	aStream cr.
	self headers writeOn: aStream.
	^self! !

!HTTPRequest methodsFor: 'private-accessing' stamp: 'DataCurator 04/23/2007 14:43'!
queries
	^self uri queries! !

!HTTPRequest methodsFor: 'accessing-queries' stamp: 'DataCurator 04/23/2007 14:43'!
queryAt: aKey 
	^self uri queryAt: aKey! !

!HTTPRequest methodsFor: 'accessing-queries' stamp: 'DataCurator 04/23/2007 14:43'!
queryAt: aKey ifAbsent: aBlock 
	^self uri queryAt: aKey ifAbsent: aBlock! !

!HTTPRequest methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
referer
	| field |
	field := self headers fieldOfClass: HTTPRefererField ifNone: [nil].
	^field isNil ifTrue: [nil] ifFalse: [field uri]! !

!HTTPRequest methodsFor: 'private' stamp: 'dkh 07/09/2007 10:30'!
request: aUriString from: aHostString at: anIPString 
	"For testing only (I'm guessing / hoping!!).
A request is manufactured that has a request line method of >>methodName and a request line URI with an identifier of aUriString.  A Host header is added to the headers and the ip address is set to anIP string.  I also set the HTTP version to #(1 1).
This may result in a corrupt or invalid request, but that's the natutre of testing, I guess."

	requestLine := (HTTPRequestLine new)
				method: self class methodName;
				requestURI: ((HyURI new)
							identifier: aUriString;
							yourself);
				httpVersion: #(1 1);
				yourself.
	self headers addField: (HTTPHostField newWithValueFrom: aHostString).
	self ip: anIPString.
	^self! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
requestLine
	"^an HTTPRequestLine"

	requestLine isNil ifTrue: [requestLine := HTTPRequestLine new].
	^requestLine! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
resolution
	^resolution! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
resolution: anObject
	resolution := anObject! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
resourcePath
	^self resolution resourcePath! !

!HTTPRequest methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
respondUsing: responseBlock 
	"^an HTTPResponse
By default, I let aBlock handle creating the response by passing myself as the agrument to the block.  My subclasses may override this method and directly respond.  This is most likely for Unsupported requests and for things like OPTIONS requsts.  c.f. HTTPServer>>answerTo: "

	^responseBlock value: self! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
rootConstruct: aString 
	| ws path |
	ws := WriteStream on: String new.
	path := self resourcePath.
	path first = '/' ifTrue: [ws nextPutAll: path removeFirst].
	path do: 
			[:each | 
			ws
				nextPutAll: each;
				nextPut: $/].
	ws nextPutAll: aString.
	^ws contents! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
session
	^self environmentAt: #session! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
session: aSession 
	self environmentAt: #session put: aSession! !

!HTTPRequest methodsFor: 'private-accessing' stamp: 'DataCurator 04/23/2007 14:43'!
setAuthenticated 	
	authenticated := true! !

!HTTPRequest methodsFor: 'private-accessing' stamp: 'DataCurator 04/23/2007 14:43'!
setEncrypted
	encrypted := true! !

!HTTPRequest methodsFor: 'private-initialize' stamp: 'DataCurator 04/23/2007 14:43'!
setTimestamp
	timestamp := SpTimestamp now! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
tailPath
	^self resolution tailPath! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
timestamp
	timestamp isNil ifTrue: [self setTimestamp].
	^timestamp! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
uri
	^self requestLine requestURI! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
uriString
	^self uri identifier! !

!HTTPRequest methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
urlString
	^self uri value! !

!HTTPRequest methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
userAgent
	| userAgentField |
	userAgentField := self headers fieldOfClass: HTTPUserAgentField
				ifNone: [nil].
	^userAgentField isNil ifTrue: [nil] ifFalse: [userAgentField productTokens]! !

!HTTPRequest methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
wantsConnectionClose
	self isClose ifTrue: [^true].
	^self httpVersion last = 0 and: [self isKeepAlive not]! !

HTTPRequest subclass: #HTTPUnsupported
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPUnsupported class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
methodName
	"I don't ahave a name as I represent *all* unsupported methods.  Any attempt to ask my name is inapropriate."

	^self shouldNotImplement! !

!HTTPUnsupported methodsFor: 'services' stamp: 'dkh 07/09/2007 10:30'!
respondUsing: responseBlock 
	"^an HTTPResponse
The method in the request I represent is unsupported.  I respond with a 405 (method not allowed) and a list of my supported methods in an Allow: header.  I ignore the responseBlock."

	| response allowField |
	response := HTTPResponse methodNotAllowed.
	allowField := HTTPAllowField new.
	allowField methods addAll: self class httpMethodToClassDictionary keys.
	response headers addField: allowField.
	^response! !

HTTPMessage subclass: #HTTPResponse
	instanceVariableNames: 'statusLine code entity'
	classVariableNames: 'StatusCodes'
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPResponse class methodsFor: 'response types' stamp: 'DataCurator 04/23/2007 14:43'!
badRequest
	^self new code: 400! !

!HTTPResponse class methodsFor: 'Accessing' stamp: 'DataCurator 04/23/2007 14:43'!
dateString

^SpTimestamp now asRFC1123String! !

!HTTPResponse class methodsFor: 'response types' stamp: 'DataCurator 04/23/2007 14:43'!
forbidden
	^(self new)
		code: 403;
		entity: '<HTML>
<HEAD><TITLE>Forbidden</TITLE></HEAD>
<BODY>
<H1>403 Forbidden</H1>
<P>Access to the requested resource is forbidden.</P>
</BODY></HTML>';
		yourself! !

!HTTPResponse class methodsFor: 'response types' stamp: 'DataCurator 04/23/2007 14:43'!
found
	^self new code: 302! !

!HTTPResponse class methodsFor: 'class initialization' stamp: 'DataCurator 04/23/2007 14:43'!
initialize
	"HTTPResponse initialize"
self statusCodes! !

!HTTPResponse class methodsFor: 'response types' stamp: 'DataCurator 04/23/2007 14:43'!
internalServerError
	^(self new)
		code: 500;
		entity: '<HTML>
<HEAD><TITLE>Not Found</TITLE></HEAD>
<BODY>
<H1>500 Internal Server Error</H1>
<P>The server experienced an error while processing this request.  If this problem persists, please contact the webmaster.</P>
</BODY></HTML>';
		yourself! !

!HTTPResponse class methodsFor: 'response types' stamp: 'DataCurator 04/23/2007 14:43'!
methodNotAllowed
"c.f. RFC 2616  10.4.6
   The method specified in the Request-Line is not allowed for the
   resource identified by the Request-URI. The response MUST include an
   Allow header containing a list of valid methods for the requested
   resource. "
	^self new code: 405! !

!HTTPResponse class methodsFor: 'response types' stamp: 'DataCurator 04/23/2007 14:43'!
movedPermanently
	^self new code: 301! !

!HTTPResponse class methodsFor: 'response types' stamp: 'DataCurator 04/23/2007 14:43'!
notFound
	^(self new)
		code: 404;
		entity: '<HTML>
<HEAD><TITLE>Not Found</TITLE></HEAD>
<BODY>
<H1>404 Not Found</H1>
<P>The requested resource was not found on this server.</P>
</BODY></HTML>';
		yourself! !

!HTTPResponse class methodsFor: 'response types' stamp: 'DataCurator 04/23/2007 14:43'!
notImplemented
	^self new code: 501! !

!HTTPResponse class methodsFor: 'response types' stamp: 'DataCurator 04/23/2007 14:43'!
notModified
	^self new code: 304! !

!HTTPResponse class methodsFor: 'response types' stamp: 'DataCurator 04/23/2007 14:43'!
ok
	^self new code: 200! !

!HTTPResponse class methodsFor: 'instance creation' stamp: 'dkh 07/09/2007 10:30'!
readFrom: anHTTPReadStream 
	"^an HTTPResponse
I create and return a new instance of one of my subclasses which will represent the HTTP response presumed to be the contents of aStream."

	anHTTPReadStream class == HTTPReadStream ifFalse: [1 halt: 'Oops'].
	^self new readFrom: anHTTPReadStream! !

!HTTPResponse class methodsFor: 'response types' stamp: 'DataCurator 04/23/2007 14:43'!
redirectLink
	"^an HTTPResponse
Note that 302 is really the 'found' response.  This code should really be 303 (>>seeOther).  However, because many clients take 302 & 303 to be the same and because older clients don't understand 303, 302 is commonly used in this case.  See RFC 2616 10.3.4."

	^self new code: 302! !

!HTTPResponse class methodsFor: 'response types' stamp: 'DataCurator 04/23/2007 14:43'!
seeOther
	"^an HTTPResponse
The response to the request can be found under a different URI and SHOULD be retrieved using a GET method on that resource. This method exists primarily to allow the output of a POST-activated script to redirect the user agent to a selected resource.
See RFC 2616 10.3.4."

	^self new code: 303! !

!HTTPResponse class methodsFor: 'class initialization' stamp: 'DataCurator 04/23/2007 14:43'!
statusCodes
	StatusCodes isNil 
		ifTrue: 
			[StatusCodes := (Dictionary new)
						add: 100 -> 'Continue';
						add: 101 -> 'Switching Protocols';
						add: 200 -> 'OK';
						add: 201 -> 'Created';
						add: 202 -> 'Accepted';
						add: 203 -> 'Non-Authoritative Information';
						add: 204 -> 'No Content';
						add: 205 -> 'Reset Content';
						add: 206 -> 'Partial Content';
						add: 300 -> 'Multiple Choices';
						add: 301 -> 'Moved Permanently';
						add: 302 -> 'Found';
						add: 303 -> 'See Other';
						add: 304 -> 'Not Modified';
						add: 305 -> 'Use Proxy';
						add: 307 -> 'Temporary Redirect';
						add: 400 -> 'Bad Request';
						add: 401 -> 'Unauthorized';
						add: 402 -> 'Payment Required';
						add: 403 -> 'Forbidden';
						add: 404 -> 'Not Found';
						add: 405 -> 'Method Not Allowed';
						add: 406 -> 'Not Acceptable';
						add: 407 -> 'Proxy Authentication Required';
						add: 408 -> 'Request Time-out';
						add: 409 -> 'Conflict';
						add: 410 -> 'Gone';
						add: 411 -> 'Length Required';
						add: 412 -> 'Precondition Failed';
						add: 413 -> 'Request Entity Too Large';
						add: 414 -> 'Request-URI Too Large';
						add: 415 -> 'Unsupported Media Type';
						add: 416 -> 'Requested range not satisfiable';
						add: 417 -> 'Expectation Failed';
						add: 500 -> 'Internal Server Error';
						add: 501 -> 'Not Implemented';
						add: 502 -> 'Bad Gateway';
						add: 503 -> 'Service Unavailable';
						add: 504 -> 'Gateway Time-out';
						add: 505 -> 'HTTP Version not supported';
						yourself].
	^StatusCodes! !

!HTTPResponse class methodsFor: 'response types' stamp: 'DataCurator 04/23/2007 14:43'!
unauthorized
	^self new code: 401! !

!HTTPResponse methodsFor: 'private-initialize' stamp: 'DataCurator 04/23/2007 14:43'!
addDateHeader
	"^self
Note that the server must have it's clock set to GMT"

	self headers addField: (HTTPDateField new date: SpTimestamp now).
	^self! !

!HTTPResponse methodsFor: 'private-initialize' stamp: 'DataCurator 04/23/2007 14:43'!
addInitialHeaders
	self addServerHeader.
	self addDateHeader! !

!HTTPResponse methodsFor: 'private-initialize' stamp: 'DataCurator 04/23/2007 14:43'!
addServerHeader
	^self headers 
		addField: (HTTPServerField new productTokens: HTTPServer version)! !

!HTTPResponse methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
code
	^code! !

!HTTPResponse methodsFor: 'private-initialize' stamp: 'DataCurator 04/23/2007 14:43'!
code: anInteger 
	code := anInteger! !

!HTTPResponse methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
contentType
	"^a String
Return the media type from my Content-Type header field."

	^self headers 
		fieldOfClass: ContentTypeField
		ifPresent: [:field | field mediaType]
		ifAbsent: ['application/octet-stream']! !

!HTTPResponse methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
contentType: aString 
	self headers addField: (ContentTypeField new mediaType: aString).
	^self! !

!HTTPResponse methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
cookie: aString 
	| newField |
	newField := HTTPSetCookieField new.
	newField addCookie: aString.
	self headers addField: newField.
	^self! !

!HTTPResponse methodsFor: 'private-printing' stamp: 'DataCurator 04/23/2007 14:43'!
crlfOn: aStream 
	aStream
		nextPut: Character cr;
		nextPut: Character lf! !

!HTTPResponse methodsFor: 'private-printing' stamp: 'DataCurator 04/23/2007 14:43'!
endHeaderOn: aStream 
	aStream crlf.
	^self! !

!HTTPResponse methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
endStringHeaderOn: aStream 
self crlfOn: aStream! !

!HTTPResponse methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
entity
	^entity! !

!HTTPResponse methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
entity: anEntity 
	"^self
This used to convert anEntity to a ByteArray, but mls removed that.  So now an entity is not deffinitely a collection of Bytes - is this safe?  Needs review."

	SpEnvironment workInProgress.
	entity := anEntity.
	^self! !

!HTTPResponse methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
hasEntity
	^self entity notNil and: [self entity size > 0]! !

!HTTPResponse methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
hasStreamingEntity
	^(self entity isKindOf: Collection) not! !

!HTTPResponse methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
informConnectionClose
	self headers 
		fieldOfClass: HTTPConnectionField
		ifPresent: [:field | field setToClose]
		ifAbsent: [self headers addField: HTTPConnectionField new setToClose].
	^self! !

!HTTPResponse methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isBadRequest
	^self code = 400! !

!HTTPResponse methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isChunked
	^self transferEncoding = 'chunked'! !

!HTTPResponse methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isFound
	^self code = 302! !

!HTTPResponse methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isInternalServerError
	^self code = 500! !

!HTTPResponse methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isMovedPermanently
	^self code = 301! !

!HTTPResponse methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isNotFound
	^self code = 404! !

!HTTPResponse methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isNotImplemented
	^self code = 501! !

!HTTPResponse methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isNotModified
	^self code = 304! !

!HTTPResponse methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isOk
	^self code = 200! !

!HTTPResponse methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isRedirectLink
	^self code = 302! !

!HTTPResponse methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isSeeOther
	^self code = 303! !

!HTTPResponse methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
location: aString 
	self headers addField: (HTTPLocationField new uriString: aString).
	^self! !

!HTTPResponse methodsFor: 'private-printing' stamp: 'DataCurator 04/23/2007 14:43'!
printContentLengthOn: aStream 
	"^self
My entity should be a collection (or stream) of Bytes.  mls has changed the entity to be a collection/stream of whatever gets passed to me (which could be multi-byte characters - bad)."

	SpEnvironment workInProgress.
	self hasEntity 
		ifFalse: [
			aStream
				nextPutAllCHARs: 'Content-Length: ';
				nextPutAllCHARs: '0';
				crlf.
			^self
		].
	self hasStreamingEntity ifTrue: [^self].
	aStream
		nextPutAllCHARs: 'Content-Length: ';
		nextPutAllCHARs: self entity size printString;
		crlf.
	^self! !

!HTTPResponse methodsFor: 'private-printing' stamp: 'DataCurator 04/23/2007 14:43'!
printEntityOn: aStream 
	"^self
Well, this looks like we need to revise how we handle streaming.  We need to have an explicit way for people to supply an entity of bytes, or alternatively an entity of characters that gets converted to bytes, or alternatively they need to be able to write bytes or characters to a stream that flows directly out of the server.  Needs review."

	SpEnvironment workInProgress.
	self hasEntity ifFalse: [^self].
	self hasStreamingEntity 
		ifTrue: 
			[self isChunked ifTrue: [aStream setChunkedMode].
			self entity value: aStream]
		ifFalse: [aStream nextPutAll: self entity asByteArray].
	self isChunked ifTrue: [aStream nextPutAll: #()]! !

!HTTPResponse methodsFor: 'private-printing' stamp: 'DataCurator 04/23/2007 14:43'!
printHeadersOn: aStream 
	"^self
Write the headers (key-value pairs) to aStream.  The key
must be a String."

	self headers fields do: 
			[:aField | 
			aField writeTo: aStream.
			aStream crlf]! !

!HTTPResponse methodsFor: 'private-printing' stamp: 'DataCurator 04/23/2007 14:43'!
printStatusOn: aStream 
	aStream
		nextPutAllCHARs: 'HTTP/1.1 ';
		nextPutAllCHARs: self code printString;
		sp;
		nextPutAllCHARs: (self class statusCodes at: self code);
		crlf.
	^self! !

!HTTPResponse methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
printString

| str |
str := WriteStream on: String new.
str cr; nextPutAll: '------------------------'.
self writeStringHeaderTo: str.
self printStringEntityOn: str.
str cr; nextPutAll: '------------------------'.
^str contents! !

!HTTPResponse methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
printStringContentLengthOn: aStream 
	"^self
My entity should be a collection (or stream) of Bytes.  mls has changed the entity to be a collection/stream of whatever gets passed to me (which could be multi-byte characters - bad)."

	SpEnvironment workInProgress.
	self hasEntity 
		ifFalse: [
			aStream
				nextPutAll: 'content-length: ';
				nextPutAll: '0'.
      		self crlfOn: aStream.
			^self
		].
	self hasStreamingEntity ifTrue: [^self].
	aStream
		nextPutAll: 'Content-Length: ';
		nextPutAll: self entity size printString.
      self crlfOn: aStream.
	^self! !

!HTTPResponse methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
printStringEntityOn: aStream 
	"^self
Well, this looks like we need to revise how we handle streaming.  We need to have an explicit way for people to supply an entity of bytes, or alternatively an entity of characters that gets converted to bytes, or alternatively they need to be able to write bytes or characters to a stream that flows directly out of the server.  Needs review."

	SpEnvironment workInProgress.
	self hasEntity ifFalse: [^self].
	self hasStreamingEntity 
		ifTrue: 
			[self isChunked ifTrue: [aStream setChunkedMode].
			self entity value: aStream]
		ifFalse: [aStream nextPutAll: self entity].! !

!HTTPResponse methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
printStringHeadersOn: aStream 
	"^self
Write the headers (key-value pairs) to aStream.  The key
must be a String."

	self headers fields do: 
			[:aField | 
			aField printOn: aStream.
			self crlfOn: aStream]! !

!HTTPResponse methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
printStringStatusOn: aStream 
	aStream
		nextPutAll: 'HTTP/1.1 ';
		nextPutAll: self code printString.
	aStream nextPut: Character space.
	aStream
		nextPutAll: (self class statusCodes at: self code).
      self crlfOn: aStream.
	^self! !

!HTTPResponse methodsFor: 'instance creation' stamp: 'DataCurator 04/23/2007 14:43'!
readFrom: aStream 
	"^self
I parse my content from a stream."

	statusLine := HTTPStatusLine readFrom: aStream.
	^self! !

!HTTPResponse methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
statusLine
	^statusLine! !

!HTTPResponse methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
transferEncoding
	"^a String
Return the transfer encoding from my Transfer-Encoding header field."

	^self headers 
		fieldOfClass: HTTPTransferEncodingField
		ifPresent: [:field | field transferEncoding]
		ifAbsent: [nil]! !

!HTTPResponse methodsFor: 'accessing-headers' stamp: 'DataCurator 04/23/2007 14:43'!
transferEncoding: aString 
	self headers addField: (HTTPTransferEncodingField new transferEncoding: aString).
	^self! !

!HTTPResponse methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
writeHeaderTo: aStream 
	self printStatusOn: aStream.
	self printHeadersOn: aStream.
	self printContentLengthOn: aStream.
	self endHeaderOn: aStream! !

!HTTPResponse methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
writeStringHeaderTo: aStream 
	self printStringStatusOn: aStream.
	self printStringHeadersOn: aStream.
	self printStringContentLengthOn: aStream.
	self endStringHeaderOn: aStream.! !

!HTTPResponse methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
writeTo: aStream 
	self writeHeaderTo: aStream.
	self printEntityOn: aStream! !

Object subclass: #HTTPPostDataArray
	instanceVariableNames: 'underlyingCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPPostDataArray methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
allAt: aKey 
	| candidates |
	candidates := self underlyingCollection 
				select: [:anAssociation | anAssociation key = aKey].
	^candidates collect: [:anAssociation| anAssociation value]! !

!HTTPPostDataArray methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
allNamesForValue: aString 
	| candidates |
	candidates := self underlyingCollection 
				select: [:anAssociation | anAssociation value value = aString].
	^candidates collect: [:anAssociation| anAssociation key]! !

!HTTPPostDataArray methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
associations
	^self underlyingCollection! !

!HTTPPostDataArray methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
at: aKey 
	^(self allAt: aKey) last! !

!HTTPPostDataArray methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
at: aKey ifAbsent: aBlock 
	| candidates |
	candidates := self underlyingCollection 
				select: [:anAssociation | anAssociation key = aKey].
	^candidates isEmpty ifTrue: [aBlock value] ifFalse: [candidates last value]! !

!HTTPPostDataArray methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
at: key put: anObject 
	self underlyingCollection add: (key -> anObject).
	^anObject! !

!HTTPPostDataArray methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
includesKey: aKey 
	| candidates |
	candidates := self underlyingCollection 
				select: [:anAssociation | anAssociation key = aKey].
	^candidates notEmpty! !

!HTTPPostDataArray methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
includesValue: aString 
	| candidates |
	candidates := self underlyingCollection 
				select: [:anAssociation | anAssociation value value = aString].
	^candidates notEmpty! !

!HTTPPostDataArray methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isEmpty
	^self underlyingCollection isEmpty! !

!HTTPPostDataArray methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
keys
"^a Set
I mimick the behavior of a Dictionay which I replace.  I return a set of the keys in my underlying collection of associations."

	^(self underlyingCollection collect: [:anAssociation| anAssociation key]) asSet! !

!HTTPPostDataArray methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
nameForValue: aString
	^(self allNamesForValue: aString) last! !

!HTTPPostDataArray methodsFor: 'enumerating' stamp: 'DataCurator 04/23/2007 14:43'!
postKeysAndValuesDo: aTwoArgumentBlock 
	self underlyingCollection do: 
		[:anAssociation | aTwoArgumentBlock value: anAssociation key value: anAssociation value]! !

!HTTPPostDataArray methodsFor: 'enumerating' stamp: 'DataCurator 04/23/2007 14:43'!
select: aBlock 
"^an Object
I run the select on the values of the associations in my underlying collection.  This mimicks the behavior when a Dictionary was used in my place."
	^self underlyingCollection select:  [:anAssociation| aBlock value: anAssociation value]! !

!HTTPPostDataArray methodsFor: 'private' stamp: 'DataCurator 04/23/2007 14:43'!
underlyingCollection
	underlyingCollection isNil 
		ifTrue: [underlyingCollection := OrderedCollection new].
	^underlyingCollection! !

Object subclass: #HTTPStream
	instanceVariableNames: 'byteStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

HTTPStream subclass: #HTTPReadStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPReadStream class methodsFor: 'instance creation' stamp: 'DataCurator 04/23/2007 14:43'!
onByteArray: aByteArray 
	"^an HTTPReadStream
aByteArray must contain only OCTETs per RFC 2616.  Really, this is for testing only.  Normally I create my instances to work with respect to a socket."

	^self onStream: (ReadStream on: aByteArray)! !

!HTTPReadStream methodsFor: 'reading CHARs' stamp: 'DataCurator 04/23/2007 14:43'!
convertOCTETsToCHARs: subjectBytes 
	| targetString |
	targetString := String new: subjectBytes size.
	1 to: subjectBytes size
		do: [:index | targetString at: index put: (subjectBytes at: index) asCharacter].
	^targetString! !

!HTTPReadStream methodsFor: 'reading OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
next
	"^an OCTET (byte) or nil
	As a temporary measure I make sure that every element I return is a byte (an Integer < 256 )."

	| subjectByte |
	SpEnvironment workInProgress.
	self byteStream atEnd ifTrue: [ ^nil ].
	subjectByte := self byteStream next.
	^subjectByte < 256
	  ifTrue: [subjectByte]
	  ifFalse: 
		[1 halt: 'Oops - that''s not an octet'.
		0]! !

!HTTPReadStream methodsFor: 'reading OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
next: numberOfBytes 
	"^a ByteArray of OCTETs
I return the next numberOfBytes from my underlying byte stream."

	^self byteStream next: numberOfBytes! !

!HTTPReadStream methodsFor: 'reading OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
nextBytes: anInteger 
	^SpEnvironment madeObsoleteBy: [self next: anInteger]! !

!HTTPReadStream methodsFor: 'reading CHARs' stamp: 'DataCurator 04/23/2007 14:43'!
nextCHAR
	"^a Character"

	^self next asCharacter! !

!HTTPReadStream methodsFor: 'reading CHARs' stamp: 'DataCurator 04/23/2007 14:43'!
nextCHARs: numberOfCHARs 
	"^a String
I return the next numberOfCHARs where each character is a CHAR as defined in RFC 2616 2.2."

	^self convertOCTETsToCHARs: (self next: numberOfCHARs)! !

!HTTPReadStream methodsFor: 'reading CHARs' stamp: 'DataCurator 04/23/2007 14:43'!
nextCHARsUpToCHAR: aCHAR 
	"^a String
Much of the Swazoo reading assumes characters rather than bytes.  Here we get the bytes from the underlying stream and convert each byte into a character."

	^self convertOCTETsToCHARs: (self upTo: aCHAR asInteger)! !

!HTTPReadStream methodsFor: 'reading CHARs' stamp: 'DataCurator 04/23/2007 14:43'!
nextLine
	"^a String
I return the next line from my underlying stream.  This means reading everything up to the next crlf."

	| targetStream |
	targetStream := WriteStream on: String new.
	self writeNextLineTo: targetStream.
	^targetStream contents! !

!HTTPReadStream methodsFor: 'reading CHARs' stamp: 'DataCurator 04/23/2007 14:43'!
nextUnfoldedLine
	"^a String
c.f. RFC 2616 2.2 Basic Rules
   HTTP/1.1 header field values can be folded onto multiple lines if the
   continuation line begins with a space or horizontal tab.
So, I read the next line, the I read subsequent lines until I get to one that is not a contuation.  I add the contents of the continuation lines to the target stream.  I leave my underlying stream positioned at the immediately after the last continuation.  If the initial line is empty this is the last line in the stream, so I read no more."

	| targetStream |
	targetStream := WriteStream on: String new.
	self writeNextLineTo: targetStream.
	targetStream contents isEmpty 
		ifFalse: 
			[
			[| nextCharacter |
			nextCharacter := self peekCHAR.
			nextCharacter notNil 
				and: [nextCharacter == Character space or: [nextCharacter == Character tab]]] 
					whileTrue: [self writeNextLineTo: targetStream]].
	^targetStream contents! !

!HTTPReadStream methodsFor: 'reading OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
peek
	"^an OCTET (byte) or nil
I return the next octet in the underlying stream if there is one."

	^self byteStream peek! !

!HTTPReadStream methodsFor: 'reading CHARs' stamp: 'DataCurator 04/23/2007 14:43'!
peekCHAR
	"^an CHAR (Character) or nil
I return the next OCTET converted to a CHAR in the underlying stream if there is one."

	| peekedOCTET |
	peekedOCTET := self peek.
	^peekedOCTET isNil ifTrue: [nil] ifFalse: [peekedOCTET asCharacter]! !

!HTTPReadStream methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
socketStreamClass
	^OSkSocketReadStream! !

!HTTPReadStream methodsFor: 'reading OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
upTo: anOCTET 
	"^a ByteArray of OCTETs
I return the OCTETs upto but excluding anOCTET."

	^self byteStream upTo: anOCTET! !

!HTTPReadStream methodsFor: 'reading OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
upToAll: aByteArray 
	"^a ByteArray of OCTETs
I return the OCTETs up to but excluding the contents of aByteArray (which must be OCTETs)."

	^self byteStream upToAll: aByteArray! !

!HTTPReadStream methodsFor: 'reading OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
upToEnd
	"^a ByteArray of OCTETs
I return the collection of OCTETs up to the end of my underlying stream."

	^self byteStream upToEnd! !

!HTTPReadStream methodsFor: 'reading CHARs' stamp: 'DataCurator 04/23/2007 14:43'!
writeNextLineTo: aStream 
	aStream nextPutAll: (self nextCHARsUpToCHAR: Character cr).
	self peekCHAR = Character lf 
		ifTrue: [self next]
		ifFalse: [HyHTTPParseError raiseSignal: 'CR without LF'].
	^self! !

!HTTPStream class methodsFor: 'instance creation' stamp: 'DataCurator 04/23/2007 14:43'!
onByteArray: aByteArray 
	"^an HTTPStream
aByteArray must contain only OCTETs per RFC 2616."

	^self subclassResponsibility! !

!HTTPStream class methodsFor: 'instance creation' stamp: 'DataCurator 04/23/2007 14:43'!
onSocket: aSocket 
	"^an HTTPStream
I create an instance of one of my subclasses which will use an OSkSocketStream (subclass) to move bytes over aSocket.  This is the normal way to use an HTTPStream."

	^self new onSocket: aSocket! !

!HTTPStream class methodsFor: 'instance creation' stamp: 'DataCurator 04/23/2007 14:43'!
onStream: aStream 
	"^an HTTPStream
aStream must be a Byte stream such that each >>next returns an OCTET (c.f. RFC 2616 2.2).  See my class comment."

	^self new onStream: aStream! !

!HTTPStream methodsFor: 'accessing-private' stamp: 'DataCurator 04/23/2007 14:43'!
byteStream
	"^a read stream on bytes
I return my underlying stream of octets (bytes)."

	^byteStream! !

!HTTPStream methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
contents
	"^a ByteArray"

	^self byteStream contents! !

!HTTPStream methodsFor: 'logging' stamp: 'DataCurator 04/23/2007 14:43'!
log
	"^an HTTPSocketLog
I return the socket log which currently in use by my underlying byte stream."

	^self byteStream log! !

!HTTPStream methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
onSocket: aSocket 
	"^self
I initialize myself to move bytes over aSocket via an OSkSocketStream which does buffering for me ... among other things.  My subclasses decide the specifc class of socket stream to use."

	byteStream := self socketStreamClass on: aSocket.
	^self! !

!HTTPStream methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
onStream: aStream 
	"^self
I initialize myself on aStream which must contain octets (bytes)."

	byteStream := aStream.
	^self! !

!HTTPStream methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
socketStreamClass
	^self subclassResponsibility! !

!HTTPStream methodsFor: 'logging' stamp: 'DataCurator 04/23/2007 14:43'!
startLoggingTo: aLog 
	"^self
I get my underlying byte stream to start logging."

	^self byteStream startLoggingTo: aLog! !

!HTTPStream methodsFor: 'logging' stamp: 'DataCurator 04/23/2007 14:43'!
stopLogging
	"^self
I get my underlying byte stream to stop logging."

	^self byteStream stopLogging! !

!HTTPStream methodsFor: 'accessing-private' stamp: 'DataCurator 04/23/2007 14:43'!
underlyingStream
	^SpEnvironment madeObsoleteBy: [self byteStream]! !

HTTPStream subclass: #HTTPWriteStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPWriteStream class methodsFor: 'instance creation' stamp: 'DataCurator 04/23/2007 14:43'!
onByteArray: aByteArray 
	"^an HTTPWriteStream
aByteArray must contain only OCTETs per RFC 2616."

	^self onStream: (WriteStream on: aByteArray)! !

!HTTPWriteStream methodsFor: 'writing OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
cr
	"^self
I write a CR to my underlying stream."

	self byteStream nextPut: Character cr asInteger.
	^self! !

!HTTPWriteStream methodsFor: 'writing OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
crlf
	"^self
I write a CRLF pair to my underlying stream."

	self
		cr;
		lf.
	^self! !

!HTTPWriteStream methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
flush
	^self byteStream flush! !

!HTTPWriteStream methodsFor: 'writing OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
ht
	"^self
I write a horzintal tab to my underlying stream.  HT is the term used in RFC2616."

	self byteStream nextPut: Character tab asInteger.
	^self! !

!HTTPWriteStream methodsFor: 'writing OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
lf
	"^self
I write a LF pair to my underlying stream."

	self byteStream nextPut: Character lf asInteger.
	^self! !

!HTTPWriteStream methodsFor: 'writing OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
nextPut: anOCTET 
	"^self
I write anOCTET to my underlying stream."

	^self byteStream nextPut: anOCTET! !

!HTTPWriteStream methodsFor: 'writing OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
nextPutAll: aCollectionOfBytes 
	"^self
I write aCollectionOfBytes to my underlying stream."

	^self byteStream nextPutAll: aCollectionOfBytes! !

!HTTPWriteStream methodsFor: 'writing CHARs' stamp: 'DataCurator 04/23/2007 14:43'!
nextPutAllCHARs: aCollection 
	"^self
I write aCollection of CHARs to my underlying byte stream.  Not that a CHAR must be a valid ASCII character."

	aCollection do: [:aCHAR | self nextPutCHAR: aCHAR].
	^self! !

!HTTPWriteStream methodsFor: 'writing CHARs' stamp: 'DataCurator 04/23/2007 14:43'!
nextPutCHAR: aCHAR 
	"^self
I write aCHAR to my underlying byte stream.  Not that aCHAR must be a valid ASCII character."

	self nextPut: aCHAR asInteger.
	^self! !

!HTTPWriteStream methodsFor: 'writing CHARs' stamp: 'DataCurator 04/23/2007 14:43'!
nextPutLineOfCHARs: aCollection 
	"^self
I write aCollection to my underlying stream followed by a >>crlf."

	self nextPutAllCHARs: aCollection.
	self crlf.
	^self! !

!HTTPWriteStream methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
socketStreamClass
	^OSkSocketWriteStream! !

!HTTPWriteStream methodsFor: 'writing OCTETs' stamp: 'DataCurator 04/23/2007 14:43'!
sp
	"^self
I write a space to my underlying stream.  SP is the term used in RFC2616."

	self byteStream nextPut: Character space asInteger.
	^self! !

Object subclass: #HyTask
	instanceVariableNames: 'request response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HyTask methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
request
	^request! !

!HyTask methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
request: anObject
	request := anObject! !

!HyTask methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
response
	^response! !

!HyTask methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
response: anObject
	response := anObject! !

Object subclass: #HyURI
	instanceVariableNames: 'protocol hostname port identifier queries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HyURI class methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
charFromNextTwoHexDigitsIn: byteStream 
	"^a Character
I read a byte values expressed as two hex digits (e.g. 0F) and convert the byte value to a character."

	^(SpEnvironment integerFromString: '16r' , (byteStream next: 2)) 
		asCharacter! !

!HyURI class methodsFor: 'services' stamp: 'DataCurator 04/23/2007 14:43'!
decodedHTTPFrom: aByteArray 
	"^a String
I parse aByteArray and decode any escaped characters and return the resulting string."

	| targetStream byteStream |
	targetStream := WriteStream on: String new.
	byteStream := ReadStream on: aByteArray.
	[byteStream atEnd] whileFalse: 
			[| char |
			char := byteStream next asCharacter.
			char = $% 
				ifTrue: [targetStream nextPut: (self charFromNextTwoHexDigitsIn: byteStream)]
				ifFalse: 
					[char == $+ 
						ifTrue: [targetStream nextPut: Character space]
						ifFalse: [targetStream nextPut: char]]].
	^targetStream contents! !

!HyURI class methodsFor: 'instance creation' stamp: 'DataCurator 04/23/2007 14:43'!
fromStream: byteStream 
	"^an HyURI
I parse an HuURI from the OCTETs in byteStream. c.f. RFC 2616 pp 5.1.2."

	^self new fromStream: byteStream! !

!HyURI class methodsFor: 'instance creation' stamp: 'DataCurator 04/23/2007 14:43'!
value: aString
	^self new value: aString! !

!HyURI methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
asString
	| targetStream |
	targetStream := WriteStream on: String new.
	self printOn: targetStream.
	^targetStream contents! !

!HyURI methodsFor: 'private-accessing' stamp: 'DataCurator 04/23/2007 14:43'!
defaultPort
	^80! !

!HyURI methodsFor: 'initialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
fromStream: byteStream 
	self readProtocolFrom: byteStream.
	self readHostFrom: byteStream.
	self readPortFrom: byteStream.
	self readIdentifierFrom: byteStream.
	self readQueryFrom: byteStream.
	^self! !

!HyURI methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
host
	| ws |
	ws := WriteStream on: String new.
	ws nextPutAll: self hostname.
	self port = self defaultPort 
		ifFalse: 
			[ws nextPut: $:.
			self port printOn: ws].
	^ws contents! !

!HyURI methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
host: aString 
	| rs |
	rs := ReadStream on: aString.
	self hostname: (rs upTo: $: ).
	rs atEnd ifFalse: [self port: rs upToEnd asNumber]! !

!HyURI methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
hostname
	^hostname! !

!HyURI methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
hostname: aHostname 
	hostname := aHostname! !

!HyURI methodsFor: 'private-initialize' stamp: 'DataCurator 04/23/2007 14:43'!
hostNameTerminators
	"^a ByteArray
The following CHARs terminate a host name.  I return them as OCTETs."

	^ByteArray 
		with: $: asInteger
		with: $/ asInteger
		with: $? asInteger! !

!HyURI methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
identifier
	^identifier! !

!HyURI methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
identifier: anObject
	identifier := anObject! !

!HyURI methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
identifierPath
	| parts |
	parts := (SpStringUtilities tokensBasedOn: '/' in: self identifier) 
				collect: [:each | HyURI decodedHTTPFrom: each].
	self identifier first = $/ ifTrue: [parts addFirst: '/'].
	^parts reject: [:each | each isEmpty]! !

!HyURI methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
identifierPathString
	"^aString
I return the 'directory' part of the path name."

	| sourceStream targetStream |
	targetStream := WriteStream on: String new.
	sourceStream := ReadStream on: self identifier.
	[sourceStream atEnd] whileFalse: 
			[| fragment |
			fragment := sourceStream throughAll: '/'.
			fragment last = $/ ifTrue: [targetStream nextPutAll: fragment]].
	^targetStream contents! !

!HyURI methodsFor: 'accessing-queries' stamp: 'DataCurator 04/23/2007 14:43'!
includesQuery: aString 
	| result |
	result := self queries detect: [:aQuery | aQuery key = aString]
				ifNone: [nil].
	^result notNil! !

!HyURI methodsFor: 'testing' stamp: 'DataCurator 04/23/2007 14:43'!
isDirectory
	^self identifier last = $/! !

!HyURI methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
port
	"^an Integer
The port number defaults to 80 for HTTP."

	^port isNil ifTrue: [80] ifFalse: [port]! !

!HyURI methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
port: anInteger 
	port := anInteger! !

!HyURI methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
printOn: characterStream 
	"^self
I write an approximate string representation of myself to characterStream.  There may be some encoding issues to deal with in the future, but for now it seems OK."

	| httpStream |
	httpStream := HTTPWriteStream onByteArray: ByteArray new.
	self writeBytesTo: httpStream.
	characterStream 
		nextPutAll: (SpStringUtilities stringFromBytes: httpStream contents).
	^self! !

!HyURI methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
protocol
	protocol isNil ifTrue: [self protocol: 'http'].
	^protocol! !

!HyURI methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
protocol: aString
	protocol := aString.! !

!HyURI methodsFor: 'accessing-queries' stamp: 'DataCurator 04/23/2007 14:43'!
queries
	"^an OrderedCollection
This is an ordered colleciton of associations.  It can't be a dictionary, because it is legal to have many entries with the same key value."

	queries isNil ifTrue: [queries := OrderedCollection new].
	^queries! !

!HyURI methodsFor: 'accessing-queries' stamp: 'DataCurator 04/23/2007 14:43'!
queries: anOrderedCollection 
	"^self
The queries must be an OrderedCollection of Associations c.f. >>queries"

	queries := anOrderedCollection.
	^self! !

!HyURI methodsFor: 'accessing-queries' stamp: 'DataCurator 04/23/2007 14:43'!
queriesNamed: aString 
	^self queries select: [:aQuery | aQuery key = aString]! !

!HyURI methodsFor: 'accessing-queries' stamp: 'DataCurator 04/23/2007 14:43'!
queryAt: aString 
	^self queryAt: aString ifAbsent: [nil]! !

!HyURI methodsFor: 'accessing-queries' stamp: 'DataCurator 04/23/2007 14:43'!
queryAt: aString ifAbsent: aBlock 
	"^aString
I return the value of the first query I find with the key aString.  If there are none I execute aBlock."

	| result |
	result := self queries detect: [:aQuery | aQuery key = aString]
				ifNone: aBlock.
	^result isNil ifTrue: [aBlock value] ifFalse: [result value]! !

!HyURI methodsFor: 'private-initialize' stamp: 'DataCurator 04/23/2007 14:43'!
readHostFrom: byteStream 
	"^self
I read the host name from the URI presumed to be in byteStream.  The stream should be positioned right at the start, or just after the '//' of the protocol.  The host name is terminated by one of $:, $/, $? or the end of the stream depending on wether there is a port, path, query or nothing following the host.  If the host name is of zero length, I record a nil host name.  The stream is left positioned at the terminating character."

	| hostnameStream |
	hostnameStream := WriteStream on: String new.
	
	[| nextByte |
	nextByte := byteStream peek.
	nextByte isNil or: [self hostNameTerminators includes: nextByte]] 
			whileFalse: [hostnameStream nextPut: byteStream next asCharacter].
	hostnameStream contents isEmpty 
		ifFalse: [hostname := hostnameStream contents].
	^self! !

!HyURI methodsFor: 'private-initialize' stamp: 'DataCurator 04/23/2007 14:43'!
readIdentifierFrom: byteStream 
	"^self
I read the identifier from he bytes in a byteStream."

	| identifierStream terminator |
	identifierStream := WriteStream on: String new.
	terminator := $? asInteger.
	
	[| nextByte |
	nextByte := byteStream peek.
	nextByte isNil or: [nextByte == terminator]] 
			whileFalse: [identifierStream nextPut: byteStream next asCharacter].
	identifierStream contents isEmpty 
		ifFalse: [identifier := identifierStream contents].
	^self! !

!HyURI methodsFor: 'private-initialize' stamp: 'DataCurator 04/23/2007 14:43'!
readPortFrom: byteStream 
	"^self
I read the port number from the URI presumed to be in byteStream.  If a port number has been specified, the stream should be positioned right at before a $: charcter.  So, if the next chacter is a :, we have a port number.  I read up to one of $/, $? or the end of the stream depending on wether there is a path, query or nothing following the host.  The stream is left positioned at the terminating byte."

	| targetStream |
	targetStream := WriteStream on: String new.
	byteStream peek == $: asInteger 
		ifTrue: 
			[| terminators |
			terminators := Array 
						with: $/
						with: $?
						with: nil.
			byteStream next.
			
			[| nextCharacter |
			nextCharacter := byteStream peek asCharacter.
			terminators includes: nextCharacter] 
					whileFalse: 
						[| nextDigit |
						nextDigit := byteStream next asCharacter.
						nextDigit isDigit ifTrue: [targetStream nextPut: nextDigit]].
			targetStream contents isEmpty 
				ifFalse: [port := targetStream contents asNumber]].
	^self! !

!HyURI methodsFor: 'private-initialize' stamp: 'DataCurator 04/23/2007 14:43'!
readProtocolFrom: byteStream 
	"^self
I read the protocol from the URI presumed to be in byteStream.  The protocol preceeds '://' in the URI.  I leave the stream position either right after the '//' if there is a protocol, otherwise I reset the position to the start of the stream."

	| candidateProtocol |
	candidateProtocol := byteStream upTo: $: asInteger.
	"Original algorithm used byteStream>>size (dkh - 2006/10/11)"
	(byteStream peek == $/ asInteger and: [byteStream peek == $/ asInteger])
 	  ifTrue: [
		byteStream position: byteStream position + 2.
		self protocol: (SpStringUtilities stringFromBytes: candidateProtocol)
    		]
	  ifFalse: [ byteStream reset ].
	^self! !

!HyURI methodsFor: 'private-initialize' stamp: 'dkh 07/10/2007 09:16'!
readQueryFrom: byteStream 
	"^self
This is a first-cut at getting query values into an ordered collection of associations.  This is very crude, and should be changed to look for terminating characters rather than assuming that the end of the stream is the end of the URI."

	byteStream peek == $? asInteger ifTrue: [byteStream next].
	[byteStream atEnd] whileFalse: 
			[| query name stringValue nameIndex |
			query := SpStringUtilities stringFromBytes: (byteStream upTo: $& asInteger).
			nameIndex := query indexOf: $= startingAt: 1.
			nameIndex == 0
				ifTrue: [
					"no '=' in query."
					self queries add: query -> query
				]
				ifFalse: [
					name := query copyFrom: 1 to: (nameIndex - 1).
					stringValue := HyURI decodedHTTPFrom: (query copyFrom: (nameIndex + 1) to: query size).
					self queries add: name -> stringValue].
		].
	^self! !

!HyURI methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
value
	1 halt: 'Use >>asString or >>printOn: instead'.
	^self asString! !

!HyURI methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
writeBytesTo: targetStream 
	(self hostname notNil and: [self protocol notNil]) 
		ifTrue: 
			[targetStream
				nextPutAllCHARs: self protocol;
				nextPutAllCHARs: '://'].
	self hostname isNil ifFalse: [targetStream nextPutAllCHARs: self hostname].
	(self port notNil and: [self port ~= 80]) 
		ifTrue: 
			[targetStream
				nextPutCHAR: $:;
				nextPutAllCHARs: self port printString].
	self identifier notNil 
		ifTrue: [targetStream nextPutAllCHARs: self identifier].
	self writeQueriesTo: targetStream.
	^self! !

!HyURI methodsFor: 'printing' stamp: 'DataCurator 04/23/2007 14:43'!
writeQueriesTo: httpStream 
	| firstQuery |
	self queries isEmpty 
		ifFalse: 
			[firstQuery := self queries at: 1.
			httpStream
				nextPutCHAR: $?;
				nextPutAllCHARs: firstQuery key;
				nextPutCHAR: $=;
				nextPutAllCHARs: firstQuery value.
			2 to: self queries size
				do: 
					[:queryIndex | 
					| aQuery |
					aQuery := self queries at: queryIndex.
					httpStream
						nextPutCHAR: $&;
						nextPutAllCHARs: aQuery key;
						nextPutCHAR: $=;
						nextPutAllCHARs: aQuery value]].
	^self! !

Object subclass: #MimeObject
	instanceVariableNames: 'contentType value filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

MimeObject subclass: #HTTPPostDatum
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPPostDatum methodsFor: 'private-accessing' stamp: 'DataCurator 04/23/2007 14:43'!
defaultContentType
	^'text/plain'! !

!MimeObject methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
contentType
	^contentType isNil ifTrue: [self defaultContentType] ifFalse: [contentType]! !

!MimeObject methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
contentType: anObject
	contentType := anObject! !

!MimeObject methodsFor: 'private-accessing' stamp: 'DataCurator 04/23/2007 14:43'!
defaultContentType
	^'application/octet-stream'! !

!MimeObject methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
filename

	^filename! !

!MimeObject methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
filename: aString

	filename := aString! !

!MimeObject methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
value
	^value! !

!MimeObject methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
value: anObject
	value := anObject! !

OSkSocketListenerService subclass: #HTTPServer
	instanceVariableNames: 'responseBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hyper'!

!HTTPServer class methodsFor: 'defaults' stamp: 'DataCurator 04/23/2007 14:43'!
defaultPortNumber
	^80! !

!HTTPServer class methodsFor: 'intialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
initialize
	SpEnvironment addImageShutdownTask: [self shutDown] for: self! !

!HTTPServer class methodsFor: 'intialize-release' stamp: 'DataCurator 04/23/2007 14:43'!
shutDown
	"HTTPServer shutDown"

	self allInstances do: [:each | each stop].
	SpEnvironment removeShutdownActionFor: self.
	^self! !

!HTTPServer class methodsFor: 'accessing' stamp: 'DataCurator 04/23/2007 14:43'!
version
	^'Hyper v1 (Hyper is a Smalltalk HTTP server)'! !

!HTTPServer methodsFor: 'serving' stamp: 'DataCurator 04/23/2007 14:43'!
answerTo: aRequest 
	"^an HTTPResponse
	I return the response created on the basis of aRequest.  This is where the resource franework hooks in, and by default the Swazoo resource framework is used.  The request is asked to initiate the response because the specific request may want to respond without involving the resource, for example this could be an OPTIONS or a TRACE request."

	| response |
	response := aRequest respondUsing: self responseBlock.
	(aRequest httpVersion last = 1 
		and: [response transferEncoding isNil and: [response hasStreamingEntity]]) 
			ifTrue: [response transferEncoding: 'chunked'].
	^response! !

!HTTPServer methodsFor: 'serving' stamp: 'dkh 07/09/2007 10:30'!
inboundConnectionClass
	"^a Class
I return the HTTPConnection class whose instances know how to handle HTTP requests and make HTTPResponses."

	^HTTPConnection! !

!HTTPServer methodsFor: 'death row' stamp: 'DataCurator 04/23/2007 14:43'!
ip
	^SpEnvironment madeObsoleteBy: [self hostName]! !

!HTTPServer methodsFor: 'death row' stamp: 'DataCurator 04/23/2007 14:43'!
ip: anIPString 
	^SpEnvironment madeObsoleteBy: [self hostName: anIPString]! !

!HTTPServer methodsFor: 'death row' stamp: 'DataCurator 04/23/2007 14:43'!
isMultiThreading
	^SpEnvironment madeObsoleteBy: [self multiThreading]! !

!HTTPServer methodsFor: 'death row' stamp: 'DataCurator 04/23/2007 14:43'!
isRunning
	^SpEnvironment madeObsoleteBy: [self isStarted]! !

!HTTPServer methodsFor: 'death row' stamp: 'DataCurator 04/23/2007 14:43'!
mainLoopInForeground
	^SpEnvironment madeObsoleteBy: [self acceptInForeground]! !

!HTTPServer methodsFor: 'death row' stamp: 'DataCurator 04/23/2007 14:43'!
mainLoopInForeground: aBoolean 
	^SpEnvironment madeObsoleteBy: [self acceptInForeground: aBoolean]! !

!HTTPServer methodsFor: 'death row' stamp: 'DataCurator 04/23/2007 14:43'!
port
	^SpEnvironment madeObsoleteBy: [self portNumber]! !

!HTTPServer methodsFor: 'death row' stamp: 'DataCurator 04/23/2007 14:43'!
port: aNumber 
	^SpEnvironment madeObsoleteBy: [self portNumber: aNumber]! !

!HTTPServer methodsFor: 'serving' stamp: 'dkh 07/09/2007 10:30'!
responseBlock
	"^a Block
This is the default response block for the HTTP server.  It simply returns a not found (404).  It is, of course, anticipated that serious users of the HTTP server will set their own response block using >>responseBlock."

	responseBlock isNil 
		ifTrue: [responseBlock := [:aRequest | HTTPResponse notFound]].
	^responseBlock! !

!HTTPServer methodsFor: 'serving' stamp: 'DataCurator 04/23/2007 14:43'!
responseBlock: aBlock 
	"^self
I record the block that will be evaluated to respond to an HTTPRequest.  c.f. >>responseBlock"

	responseBlock := aBlock.
	^self! !

!HTTPServer methodsFor: 'death row' stamp: 'DataCurator 04/23/2007 14:43'!
setMultiThreading
	^SpEnvironment madeObsoleteBy: [self multiThreading: true]! !

!HTTPServer methodsFor: 'death row' stamp: 'DataCurator 04/23/2007 14:43'!
setSingleThreading
	^SpEnvironment madeObsoleteBy: [self multiThreading: false]! !
HeaderField initialize!
HTTPRequest initialize!
HTTPResponse initialize!
HTTPServer initialize!
